/*
 * NVIDIA_COPYRIGHT_BEGIN
 *
 * Copyright 1999-2001 by NVIDIA Corporation.  All rights reserved.  All
 * information contained herein is proprietary and confidential to NVIDIA
 * Corporation.  Any use, reproduction, or disclosure without the written
 * permission of NVIDIA Corporation is prohibited.
 *
 * NVIDIA_COPYRIGHT_END
 */

//
// GLRandom (Random OpenGL 3d graphics) test
//

#include "glr_comm.h"   // common JS and C++ defines (picker indexes)

var g_GlrandomId = "$Id: //sw/nvr40/diag/mods/js/glrandom.js#14 $"

//
// Set some default values for running GLRandom.
//
if (undefined == GLRandom.Golden)
{
   GLRandom.Golden = new Object;
}
if (undefined == GLRandom.TestConfiguration)
{
   GLRandom.TestConfiguration = new Object;
}
if (undefined == GLRandom.DefaultPickersSet)
{
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.DefaultPickersSet = true;
}

GLRandom.TestConfiguration.RestartSkipCount  = 500;   // clear screen after every N draws
GLRandom.Golden.SkipCount                    = 500;   // check CRC 1 time per restart point

//
// Note: we have to work on 8mb tnt2 vanta cards.
//       1024*768*4 * (front + back + depth) == more than 8 mb of framebuffer.
//       So, we default to single-buffered.
//
GLRandom.DoubleBuffer = false;


//
// Set some operating-system specific things:
//
if((OperatingSystem == "Dos") ||
   (OperatingSystem == "Xos") ||
   (OperatingSystem == "MacOSX"))
{
   // We are using our own custom GL driver...

   if (undefined == DosOpenGL.Registry)
   {
      DosOpenGL.Registry = new Object;
   }
   DosOpenGL.Registry.NV15Alines    = 2;
   DosOpenGL.Registry["34A73BC8"]   = 0x69011EE7;
   DosOpenGL.Registry["094313"]     = 0x09431392;
   DosOpenGL.Registry["d0e9a4d7"]   = 0xE;
   DosOpenGL.Registry.NotifierTimeoutSec = 10;
   DosOpenGL.Registry.MultisampleCompatibility = 0;

}
if( OperatingSystem == "Mac" )
{
   // Don't use the top few lines, to avoid repeatability problems with the
   // flashing appletalk-busy icon.
   GLRandom.TopBorder = 30;
}
if( OperatingSystem == "Win" )
{
   GLRandom.FullScreen = false;
   GLRandom.DoubleBuffer = true;
}
else
{
   GLRandom.FullScreen = true;
}


//
// Stuff copied from <gl/gl.h>
//
// It would be nice if we could just use that file directly...
//
#define GL_FLAT                           0x1D00
#define GL_SMOOTH                         0x1D01
#define GL_POINTS                         0
#define GL_LINES                          1
#define GL_LINE_LOOP                      2
#define GL_LINE_STRIP                     3
#define GL_TRIANGLES                      4
#define GL_TRIANGLE_STRIP                 5
#define GL_TRIANGLE_FAN                   6
#define GL_QUADS                          7
#define GL_QUAD_STRIP                     8
#define GL_POLYGON                        9
#define GL_SHORT                          0x1402
#define GL_FLOAT                          0x1406
#define GL_FALSE                          0
#define GL_TRUE                           1
#define GL_POINT                          0x1B00
#define GL_LINE                           0x1B01
#define GL_FILL                           0x1B02
#define GL_CW                             0x0900
#define GL_CCW                            0x0901
#define GL_FRONT                          0x0404
#define GL_BACK                           0x0405
#define GL_FRONT_AND_BACK                 0x0408
#define GL_SINGLE_COLOR                   0x81F9
#define GL_SEPARATE_SPECULAR_COLOR        0x81FA
#define GL_EMISSION                       0x1600
#define GL_SHININESS                      0x1601
#define GL_AMBIENT_AND_DIFFUSE            0x1602
#define GL_COLOR_INDEXES                  0x1603
#define GL_DIFFUSE                        0x1201
#define GL_TEXTURE_1D                     0x0DE0
#define GL_TEXTURE_2D                     0x0DE1
#define GL_TEXTURE_3D                     0x806F
#define GL_TEXTURE_CUBE_MAP_EXT           0x8513
#define GL_TEXTURE_RECTANGLE_NV           0x84F5
#define GL_EYE_RADIAL_NV                  0x855B
#define GL_EYE_PLANE_ABSOLUTE_NV          0x855C
#define GL_EYE_PLANE                      0x2502
#define GL_CLAMP                          0x2900
#define GL_CLAMP_TO_EDGE                  0x812F
#define GL_CLAMP_TO_BORDER_ARB            0x812D
#define GL_REPEAT                         0x2901
#define GL_MIRRORED_REPEAT_IBM            0x8370
#define GL_NEAREST                        0x2600
#define GL_LINEAR                         0x2601
#define GL_NEAREST_MIPMAP_NEAREST         0x2700
#define GL_LINEAR_MIPMAP_NEAREST          0x2701
#define GL_NEAREST_MIPMAP_LINEAR          0x2702
#define GL_LINEAR_MIPMAP_LINEAR           0x2703
#define GL_EYE_LINEAR                     0x2400
#define GL_OBJECT_LINEAR                  0x2401
#define GL_SPHERE_MAP                     0x2402
#define GL_NORMAL_MAP_EXT                 0x8511
#define GL_REFLECTION_MAP_EXT             0x8512
#define GL_EMBOSS_MAP_NV                  0x855F
#define GL_ALPHA                          0x1906
#define GL_RGB                            0x1907
#define GL_RGBA                           0x1908
#define GL_LUMINANCE                      0x1909
#define GL_LUMINANCE_ALPHA                0x190A
#define GL_INTENSITY                      0x8049
#define GL_COMPRESSED_RGB_S3TC_DXT1_EXT   0x83F0
#define GL_COMPRESSED_RGBA_S3TC_DXT1_EXT  0x83F1
#define GL_COMPRESSED_RGBA_S3TC_DXT3_EXT  0x83F2
#define GL_COMPRESSED_RGBA_S3TC_DXT5_EXT  0x83F3
#define GL_COLOR_INDEX8_EXT               0x80E5
#define GL_SIGNED_RGBA_NV                 0x86FB
#define GL_SIGNED_RGB_NV                  0x86FE
#define GL_SIGNED_LUMINANCE_NV            0x8701
#define GL_SIGNED_LUMINANCE_ALPHA_NV      0x8703
#define GL_SIGNED_ALPHA_NV                0x8705
#define GL_SIGNED_INTENSITY_NV            0x8707
#define GL_SIGNED_RGB_UNSIGNED_ALPHA_NV   0x870C
#define GL_HILO_NV                        0x86F4
#define GL_SIGNED_HILO_NV                 0x86F9
#define GL_DSDT_NV                        0x86F5
#define GL_DSDT_MAG_NV                    0x86F6
#define GL_DSDT_MAG_INTENSITY_NV          0x86DC
#define GL_LINEAR                         0x2601
#define GL_EXP                            0x0800
#define GL_EXP2                           0x0801
#define GL_FOG_COORDINATE_EXT             0x8451
#define GL_FRAGMENT_DEPTH_EXT             0x8452
#define GL_NEVER                          0x0200
#define GL_LESS                           0x0201
#define GL_EQUAL                          0x0202
#define GL_LEQUAL                         0x0203
#define GL_GREATER                        0x0204
#define GL_NOTEQUAL                       0x0205
#define GL_GEQUAL                         0x0206
#define GL_ALWAYS                         0x0207
#define GL_ZERO                           0
#define GL_ONE                            1
#define GL_SRC_COLOR                      0x0300
#define GL_ONE_MINUS_SRC_COLOR            0x0301
#define GL_SRC_ALPHA                      0x0302
#define GL_ONE_MINUS_SRC_ALPHA            0x0303
#define GL_DST_ALPHA                      0x0304
#define GL_ONE_MINUS_DST_ALPHA            0x0305
#define GL_DST_COLOR                      0x0306
#define GL_ONE_MINUS_DST_COLOR            0x0307
#define GL_SRC_ALPHA_SATURATE             0x0308
#define GL_CONSTANT_COLOR_EXT             0x8001
#define GL_ONE_MINUS_CONSTANT_COLOR_EXT   0x8002
#define GL_CONSTANT_ALPHA_EXT             0x8003
#define GL_ONE_MINUS_CONSTANT_ALPHA_EXT   0x8004
#define GL_FUNC_ADD_EXT                   0x8006
#define GL_MIN_EXT                        0x8007
#define GL_MAX_EXT                        0x8008
#define GL_BLEND_EQUATION_EXT             0x8009
#define GL_FUNC_SUBTRACT_EXT              0x800A
#define GL_FUNC_REVERSE_SUBTRACT_EXT      0x800B
#define GL_CLEAR                          0x1500
#define GL_AND                            0x1501
#define GL_AND_REVERSE                    0x1502
#define GL_COPY                           0x1503
#define GL_AND_INVERTED                   0x1504
#define GL_NOOP                           0x1505
#define GL_XOR                            0x1506
#define GL_OR                             0x1507
#define GL_NOR                            0x1508
#define GL_EQUIV                          0x1509
#define GL_INVERT                         0x150A
#define GL_OR_REVERSE                     0x150B
#define GL_COPY_INVERTED                  0x150C
#define GL_OR_INVERTED                    0x150D
#define GL_NAND                           0x150E
#define GL_SET                            0x150F
#define GL_ZERO                           0
#define GL_KEEP                           0x1E00
#define GL_REPLACE                        0x1E01
#define GL_INCR                           0x1E02
#define GL_DECR                           0x1E03
#define GL_INVERT                         0x150A
#define GL_INCR_WRAP_EXT                  0x8507
#define GL_DECR_WRAP_EXT                  0x8508
#define GL_PRIMARY_COLOR_NV               0x852C
#define GL_SECONDARY_COLOR_NV             0x852D
#define GL_TEXTURE0_ARB                   0x84C0
#define GL_TEXTURE1_ARB                   0x84C1
#define GL_TEXTURE2_ARB                   0x84C2
#define GL_TEXTURE3_ARB                   0x84C3
#define GL_TEXTURE4_ARB                   0x84C4
#define GL_SPARE0_NV                      0x852E
#define GL_SPARE1_NV                      0x852F
#define GL_FOG                            0x0B60
#define GL_CONSTANT_COLOR0_NV             0x852A
#define GL_CONSTANT_COLOR1_NV             0x852B
#define GL_DISCARD_NV                     0x8530
#define GL_HILO8_NV                       0x885E
#define GL_SIGNED_HILO8_NV                0x885F
#define GL_FORCE_BLUE_TO_ONE_NV           0x8860
#define GL_EXPAND_NORMAL_NV               0x8538
#define GL_UNSIGNED_IDENTITY_NV           0x8536
#define GL_FLOAT_R16_NV                   0x8884
#define GL_FLOAT_R32_NV                   0x8885
#define GL_FLOAT_RG16_NV                  0x8886
#define GL_FLOAT_RG32_NV                  0x8887
#define GL_FLOAT_RGB16_NV                 0x8888
#define GL_FLOAT_RGB32_NV                 0x8889
#define GL_FLOAT_RGBA16_NV                0x888A
#define GL_FLOAT_RGBA32_NV                0x888B
#define GL_RGB5                           0x8050
#define GL_RGB8                           0x8051
#define GL_RGBA4                          0x8056
#define GL_RGB5_A1                        0x8057
#define GL_RGBA8                          0x8058
#define GL_ALPHA8                         0x803C
#define GL_LUMINANCE8                     0x8040
#define GL_LUMINANCE8_ALPHA8              0x8045
#define GL_INTENSITY8                     0x804B
#define GL_HILO16_NV                      0x86F8
#define GL_SIGNED_HILO16_NV               0x86FA
#define GL_SIGNED_RGBA8_NV                0x86FC
#define GL_SIGNED_RGB8_NV                 0x86FF
#define GL_SIGNED_LUMINANCE8_NV           0x8702
#define GL_SIGNED_LUMINANCE8_ALPHA8_NV    0x8704
#define GL_SIGNED_ALPHA8_NV               0x8706
#define GL_SIGNED_INTENSITY8_NV           0x8708
#define GL_DSDT8_NV                       0x8709
#define GL_DSDT8_MAG8_NV                  0x870A
#define GL_DSDT8_MAG8_INTENSITY8_NV       0x870B
#define GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV 0x870D
#define GL_DEPTH_COMPONENT16_SGIX         0x81A5
#define GL_DEPTH_COMPONENT24_SGIX         0x81A6
#define GL_HALF_FLOAT_NV                  0x140B



#define NV_CFG_GRAPHICS_CAPS                    18

#define NV_CFG_GRAPHICS_CAPS_UNKNOWN            0x00000000
#define NV_CFG_GRAPHICS_CAPS_MAXCLIPS_MASK      0x000000FF  // bits 7:0
#define NV_CFG_GRAPHICS_CAPS_MAXCLIPS_SHIFT     0
#define NV_CFG_GRAPHICS_CAPS_AA_LINES           0x00000100  // bit  8
#define NV_CFG_GRAPHICS_CAPS_AA_POLYS           0x00000200  // bit  9
#define NV_CFG_GRAPHICS_CAPS_AKILL_USERCLIP     0x00000400  // bit 10
#define NV_CFG_GRAPHICS_CAPS_LOGIC_OPS          0x00000800  // bit 11
#define NV_CFG_GRAPHICS_CAPS_NV15_ALINES        0x00001000  // bit 12
#define NV_CFG_GRAPHICS_CAPS_2SIDED_LIGHTING    0x00002000  // bit 13
#define NV_CFG_GRAPHICS_CAPS_QUADRO_GENERIC     0x00004000  // bit 14
#define NV_CFG_GRAPHICS_CAPS_UBB                0x00008000  // bit 15
#define NV_CFG_GRAPHICS_CAPS_NV1X_COLOR_INVARIANCE 0x00010000  // bit 16
#define NV_CFG_GRAPHICS_CAPS_3D_TEXTURES        0x00020000  // bit 17
#define NV_CFG_GRAPHICS_CAPS_ANISOTROPIC        0x00040000  // bit 18
#define NV_CFG_GRAPHICS_CAPS_CLIPPED_ALINES     0x00080000  // bit 19

if (Official)
   PowerPusher = new Object;

PowerPusher.TestConfiguration = {};
PowerPusher.TestConfiguration.UseTiledSurface = true;
PowerPusher.TestConfiguration.DisplayWidth   = 1024;
PowerPusher.TestConfiguration.DisplayHeight  = 768;
PowerPusher.TestConfiguration.DisplayDepth   = 32;
PowerPusher.ZDepth                           = 32;

PowerPusher.DoubleBuffer   = true;
PowerPusher.LoopMs         = 10000;

PowerPusher.TessRate       = 32;
PowerPusher.Texture        = true;
PowerPusher.TxSize         = 16;
PowerPusher.TxFilterLinear = true;
PowerPusher.TxBitDepth     = 16;
PowerPusher.TxD            = 1.5;   // If TxD > 0, texture is minified, else magnified.
PowerPusher.TxCheckers     = true;
PowerPusher.Stipple        = false;
PowerPusher.Light          = true;
PowerPusher.Line           = false;
PowerPusher.ReadC          = true;
PowerPusher.WriteC         = true;
PowerPusher.ReadZ          = true;
PowerPusher.WriteZ         = true;

//------------------------------------------------------------------------------
// Print details of how bad the interleaved checksums miscompare was.
//
function glr_print_miscompare_details()
{
   var FrameErrs = GLRandom.GetFrameErrCounts();

   Out.Printf(Out.PriHigh,
         "Frame errs/tries: %d/%d  Frames: %d,%d,%d,%d,%d (sft,mix,hrd,hang,OK)\n",
         FrameErrs[6], FrameErrs[5],
         FrameErrs[1], FrameErrs[2], FrameErrs[3], FrameErrs[4], FrameErrs[0]
         );

   var badFrames = FrameErrs[6] ? FrameErrs[6] : 1;
   if (undefined == GLRandom.Golden.NumCodeBins)
      GLRandom.Golden.NumCodeBins = Golden.NumCodeBins;

   Out.Printf(Out.PriHigh,
         "Last frame=%d, err,diff bins %d,%d in %d*%d, accum-diffs %d %d %d %d %d %d (argbsd)\n",
         Math.floor(GLRandom.Loop / GLRandom.TestConfiguration.RestartSkipCount),
         GLRandom.Golden.TotalBinErrors,
         GLRandom.Golden.TotalBinMiscompares,
         badFrames, GLRandom.Golden.NumCodeBins,
         GLRandom.Golden.TotalCheckSumDiffs[0],
         GLRandom.Golden.TotalCheckSumDiffs[1],
         GLRandom.Golden.TotalCheckSumDiffs[2],
         GLRandom.Golden.TotalCheckSumDiffs[3],
         GLRandom.Golden.TotalCheckSumDiffs[4],
         GLRandom.Golden.TotalCheckSumDiffs[5] );

   return 0;
}
Log.Never("glr_print_miscompare_details");

//------------------------------------------------------------------------------
// Use GLRandom to exercise and test the 3D graphics hardware.
//
function glr_hwtest()
{
   if (GLRandom.CustomerGen)
      return glr_mark_golden_recs();
   
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_avoid_software_paths();

   Log.Never("GLRandom.Run");

   var rc = GLRandom.Run();
   if (rc)
      glr_print_miscompare_details();

   Log.OnError("GLRandom.Run");

   if (OperatingSystem == "Mac")
   {
      var FrameErrs = GLRandom.GetFrameErrCounts();
      var oldLogFile = Out.FileName;
      Out.Close();
      Out.Open("glr_hwtest.log", Out.Append);
      Out.Printf(Out.FileOnly,
            "rc=%d hard=%d soft=%d frame_errs=%d last_frame=%d \n",
            rc,
            FrameErrs[2] + FrameErrs[3] + FrameErrs[4],
            FrameErrs[1],
            FrameErrs[6],
            Math.floor(GLRandom.Loop / GLRandom.TestConfiguration.RestartSkipCount)
            );
      Out.Close();
      Out.Open(oldLogFile, Out.Append);
   }
   return rc;
}

function glr_avoid_software_paths()
{
   //
   // These are never useful for hardware testing.
   //
   GLRandom.SetPicker(RND_PRIM_POINT_SMOOTH_ENABLE,   [ GL_FALSE ]);
   GLRandom.SetPicker(RND_TX_BASE_MM,                 [ 0 ]);
   GLRandom.SetPicker(RND_VXFMT_HAS_EDGE_FLAG,        [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VX_EDGE_FLAG,               [ GL_TRUE ]);

   //
   // 32-bit vs 16-bit depth:
   //
   if( undefined == GLRandom.TestConfiguration.DisplayDepth )
   {
      GLRandom.TestConfiguration.DisplayDepth = TestConfiguration.DisplayDepth;
   }
   if( undefined == GLRandom.TestConfiguration.ZDepth )
   {
      GLRandom.TestConfiguration.ZDepth       = TestConfiguration.ZDepth;
   }
   if( GLRandom.TestConfiguration.DisplayDepth < 32 )
   {
      GLRandom.SetPicker(RND_FRAG_ALPHA_FUNC,              [ GL_FALSE ]);
   }
   if( GLRandom.TestConfiguration.ZDepth < 32 )
   {
      GLRandom.SetPicker(RND_FRAG_STENCIL_FUNC,            [ GL_FALSE ]);
   }

   //
   // HW capabilities (from ResMan) of the graphics engine:
   //
   var caps = [];
   NvRm.ConfigGet(NV_CFG_GRAPHICS_CAPS, caps);

   if (!(caps[0] & NV_CFG_GRAPHICS_CAPS_AA_LINES))
      GLRandom.SetPicker(RND_PRIM_LINE_SMOOTH_ENABLE, [ GL_FALSE ]);

   if (!(caps[0] & NV_CFG_GRAPHICS_CAPS_AA_POLYS))
      GLRandom.SetPicker(RND_PRIM_POLY_SMOOTH_ENABLE, [ GL_FALSE ]);

   if (!(caps[0] & NV_CFG_GRAPHICS_CAPS_LOGIC_OPS))
      GLRandom.SetPicker(RND_FRAG_LOGIC_OP, [ GL_FALSE ]);

   if (!(caps[0] & NV_CFG_GRAPHICS_CAPS_2SIDED_LIGHTING))
      GLRandom.SetPicker(RND_LIGHT_MODEL_TWO_SIDE, [ GL_FALSE ]);

   // Use different golden values for Quadro boards vs. business/gamer boards.
   if (caps[0] & NV_CFG_GRAPHICS_CAPS_QUADRO_GENERIC)
      GLRandom.Golden.Name = Golden.Name + "GL";
   else
      GLRandom.Golden.Name = Golden.Name;

   //
   // Chip families:
   //
   if (Gpu.PciDeviceId <  0x0100)
   {
      // TNT, TNT2 family

      // No hardware transform or lighting.
      GLRandom.SetPicker(RND_GEOM_TXU_GEN_ENABLED, [ GL_FALSE ]);
      GLRandom.SetPicker(RND_FOG_COORD,            [ GL_FOG_COORDINATE_EXT ]);
      GLRandom.SetPicker(RND_LIGHT_ENABLE,         [ GL_FALSE ]);
      GLRandom.SetPicker(RND_GEOM_VERTEX_WEIGHTING_ENABLE, [ GL_FALSE ]);
      GLRandom.SetPicker(RND_GEOM_VXPGM_ENABLE,    [ GL_FALSE ]);
      GLRandom.SetPicker(RND_PRIM_POINT_ATTEN_ENABLE,   [ GL_FALSE ]);
      GLRandom.SetPicker(RND_GEOM_USER_CLIP_PLANE_MASK, [ 0 ]);
      GLRandom.CompressLights   = false;
      GLRandom.UseSharedPalette = true;

      // No control of texture lookup lambda.
      GLRandom.SetPicker(RND_TXU_MAX_LAMBDA,       [ 0.0 ]);
      GLRandom.SetPicker(RND_TXU_MIN_LAMBDA,       [ 0.0 ]);
      GLRandom.SetPicker(RND_TX_BASE_MM,           [ 0 ]);
      GLRandom.SetPicker(RND_TX_MAX_MM,            [ 100 ]);

      // Other misc. GL features not supported in HW.
      GLRandom.SetPicker(RND_TX_HAS_BORDER,        [ GL_FALSE ]);
      GLRandom.SetPicker(RND_PRIM_POLY_STIPPLE_ENABLE,  [ GL_FALSE ]);
      GLRandom.SetPicker(RND_PRIM_LINE_STIPPLE_ENABLE,   [ GL_FALSE ]);
      GLRandom.SetPicker(RND_FRAG_BLEND_EQN,
      [
         [1, GL_FALSE],
         [2, GL_FUNC_ADD_EXT]
      ]);
      GLRandom.SetPicker( RND_FRAG_BLEND_SOURCE_FUNC,
      [
         [1, GL_ZERO                         ],
         [1, GL_ONE                          ],
         [1, GL_SRC_COLOR                    ],
         [1, GL_ONE_MINUS_SRC_COLOR          ],
         [1, GL_SRC_ALPHA                    ],
         [1, GL_ONE_MINUS_SRC_ALPHA          ],
         [1, GL_DST_ALPHA                    ],
         [1, GL_ONE_MINUS_DST_ALPHA          ],
         [1, GL_DST_COLOR                    ],
         [1, GL_ONE_MINUS_DST_COLOR          ],
         [1, GL_SRC_ALPHA_SATURATE           ]
      ]);

      // By sending in S,T,R instead of S,T we keep the DOS GL driver
      // from mistaking us for Quake.  There is a quake-optimized
      // path for NV4 + tri-fans + xyz,rgba,st vertexes + GL_ALPHA texture
      // that was, maybe still is, broken.
      GLRandom.SetPicker(RND_VXFMT_TXU_COORD_SIZE, [ 3 ]);
   }
   else if (Gpu.PciDeviceId < 0x0200)
   {
      // GeForce, GeForce 2, 2mx, 4mx, 2go, crush11/12, etc.

      GLRandom.SetPicker(RND_TX_HAS_BORDER,        [ GL_FALSE ]);
      GLRandom.SetPicker(RND_GEOM_VXPGM_ENABLE,    [ GL_FALSE ]);
      GLRandom.SetPicker(RND_PRIM_POLY_STIPPLE_ENABLE,  [ GL_FALSE ]);
      GLRandom.SetPicker(RND_PRIM_LINE_STIPPLE_ENABLE,   [ GL_FALSE ]);
      GLRandom.SetPicker(RND_LIGHT_MODEL_TWO_SIDE, [ GL_FALSE ]);
      GLRandom.SetPicker(RND_GEOM_USER_CLIP_PLANE_MASK, [ 0 ]);
      GLRandom.CompressLights   = false;
      GLRandom.UseSharedPalette = true;

      if ((Gpu.PciDeviceId & 0xFF0) == 0x100)
      {
         // Original nv10 had a hw bug with projective textures, worked around
         // in the GL driver by falling back to software T&L.
         // Since we want to exercise the hardware, avoid the fallback path.
         GLRandom.SetPicker(RND_GEOM_TXMX_OPERATION,
            [ "random",
               [5, RND_GEOM_TXMX_OPERATION_Identity],
               [1, RND_GEOM_TXMX_OPERATION_2dRotate],
               [1, RND_GEOM_TXMX_OPERATION_2dTranslate],
               [1, RND_GEOM_TXMX_OPERATION_2dScale],
               [2, RND_GEOM_TXMX_OPERATION_2dAll],
               [2, RND_GEOM_TXMX_OPERATION_Identity], //RND_GEOM_TXMX_OPERATION_Project],
            ] );
      }
   }
   else if (Gpu.PciDeviceId < 0x0300)
   {
      // GeForce 3, 4ti, xbox, etc.

      GLRandom.SetPicker(RND_GEOM_USER_CLIP_PLANE_MASK, [ 0 ]);
      GLRandom.SetPicker(RND_PRIM_LINE_STIPPLE_ENABLE, [GL_FALSE]);
      GLRandom.CompressLights   = false;
      GLRandom.UseSharedPalette = true;

      // @@@ WAR for bug 65932.
      GLRandom.SetPicker(RND_GEOM_VXPGM_INDEX, ["random", [1, 0, RND_GEOM_VXPGM_INDEX_NumFixedPgms]]);
   }
   else
   {
      // nv3x
      GLRandom.CompressLights   = false;
      GLRandom.UseSharedPalette = false;
   }

   // Problem seen with the DOS GL driver & nv20.
   // This extension isn't really needed for hw testing anymore, since
   // vertex_array_range works now.
   GLRandom.SetPicker(RND_VX_COMPILED_ENABLE, [ GL_FALSE ]);

   // This feature of GLRandom is still being debugged.
   GLRandom.SetPicker(RND_GEOM_USE_VX_STATE_PGM, ["random", [1, GL_FALSE]]);

   // WAR: Q37 agp is broken   
   if ( (OperatingSystem == "MacOSX") &&
        (AppleWAR & 0x2) )
         GLRandom.SetPicker[RND_VX_MEMORY_TYPE] = [ "random", [1, Memory.Pci], [1, Memory.Fb]];

   // HW supports this on some platforms, but there are DOS GL driver
   // repeatability bugs.
   GLRandom.SetPicker(RND_TX_HAS_BORDER, [ GL_FALSE ]);
   
   //
   // GLRandom self-checking feature:
   //
   // In debug builds, store or check CRCs of internal data structures and
   // generated textures, to verify that GLRandom itself is repeatable.
   //
   // In release builds, the LOGMODE picker has no effect.
   //
   if ((Golden.Store  == GLRandom.Golden.Action) ||
       ((undefined    == GLRandom.Golden.Action) &&
        (Golden.Store == Golden.Action)))
   {
      GLRandom.SetPicker(RND_TSTCTRL_LOGMODE, [ RND_TSTCTRL_LOGMODE_Store ] );
   }
   if ((Golden.Check  == GLRandom.Golden.Action) ||
       ((undefined    == GLRandom.Golden.Action) &&
        (Golden.Check == Golden.Action)))
   {
      GLRandom.SetPicker(RND_TSTCTRL_LOGMODE, [ RND_TSTCTRL_LOGMODE_Check ] );
   }
}

//------------------------------------------------------------------------------
// Test 16 bit depth and FSAA modes.
//
function glr_display(do_pause)
{
   if ((undefined == g_RequireFOS) ||
       (Golden.Check == Golden.Action))
   {
      g_RequireFOS = false;
   }
   
   // Make sure we have valid data in GLRandom.Golden and .TestConfiguration.
   if (undefined == GLRandom.Golden.SkipCount)
      GLRandom.Golden.SkipCount = Golden.SkipCount;
   if (undefined == GLRandom.Golden.Codes)
      GLRandom.Golden.Codes = Golden.Codes;
   if (undefined == GLRandom.TestConfiguration.DisplayWidth)
      GLRandom.TestConfiguration.DisplayWidth = TestConfiguration.DisplayWidth;
   if (undefined == GLRandom.TestConfiguration.DisplayHeight)
      GLRandom.TestConfiguration.DisplayHeight = TestConfiguration.DisplayHeight;
   if (undefined == GLRandom.TestConfiguration.DisplayDepth)
      GLRandom.TestConfiguration.DisplayDepth = TestConfiguration.DisplayDepth;
   if (undefined == GLRandom.TestConfiguration.ZDepth)
      GLRandom.TestConfiguration.ZDepth = TestConfiguration.ZDepth;
   if (undefined == GLRandom.TestConfiguration.Loops)
      GLRandom.TestConfiguration.Loops = TestConfiguration.Loops;

   // NV1x and NV2x can only do filter-on-scanout FSAA on head 0.
   var Head = new Array;
   var DoFOS = true;
   Display.GetHead(Display.Selected, Head);
   if ((Head[0] != 0) &&
       ((Gpu.DeviceId == Gpu.NV17) ||
        (Gpu.DeviceId == Gpu.NV18) ||
        (Gpu.DeviceId == Gpu.NV1F) ||
        (Gpu.DeviceId == Gpu.NV25) ||
        (Gpu.DeviceId == Gpu.NV28)))
   {
      if (g_RequireFOS)
      {
         Out.Printf(Out.PriHigh, "glr_display can't do FOS on head 1.\n");
         return RC.SET_MODE_FAILED;
      }
      Out.Printf(Out.PriNormal, "Skipping FOS tests, not on head 0.\n");
      DoFOS = false;
   }

   // Save away old settings so we can restore them on exit from this function.
   var oldDrawsPerFrame = GLRandom.Golden.SkipCount;
   var oldGoldenCodes   = GLRandom.Golden.Codes;
   var oldTcWidth       = GLRandom.TestConfiguration.DisplayWidth;
   var oldTcHeight      = GLRandom.TestConfiguration.DisplayHeight;
   var oldTcDepth       = GLRandom.TestConfiguration.DisplayDepth;
   var oldTcZDepth      = GLRandom.TestConfiguration.ZDepth;
   var oldColorSurfaceFormat = GLRandom.ColorSurfaceFormat;
   var oldTcLoops       = GLRandom.TestConfiguration.Loops;
   var oldFullScreen    = GLRandom.FullScreen;
   var oldDoubleBuffer  = GLRandom.DoubleBuffer;
   var oldFSAAMode      = GLRandom.FSAAMode;

   // Set some control variables for use in this function.

   var nAcross  = 5;    // bounding boxes across witdth of screen
   var nDown    = 4;    // bounding boxes down height of screen
   var loopsPerFrame = 10 * nAcross * nDown;
   var framesPerTest = 2;

   // Set up subtests.
   //
   // Don't test the plain old 2x, 15x, and 4x modes, since those are supported
   // by the old super-sampling fsaa methods on older chips.  Super-sampling
   // uses texture filtering hw that is already well tested.
   //
   // Do use double-buffer with the non-FOS fsaa modes, for efficiency (just
   // one downsample-blit instead of one per draw).
   //
   // Do use DacCrc on the FOS fsaa modes, since we need to see if the
   // downsample in the dac came out right.  Don't use DacCrc on the other
   // modes, as it misses the Z buffer and doesn't give good data on how many
   // bad pixels there were.

   var subTests    = new Object;
   var numSubTests = 0;
   subTests[ numSubTests++ ] =
      {
        Name  : "16bpp",
        Depth : 16,
        Format: 0,
        Fsaa  : GLRandom.FSAADisabled,
        DblBuf: false,
        Codes : Golden.CheckSums,
        FbSize: (640*480*2)*(1+1),
      };
   if (0) // @@@ (Gpu.PciDeviceId >= 0x300)
   {
      subTests[ numSubTests++ ] =
         {
           Name  : "float32",
           Depth : 32,
           Format: GL_FLOAT_R32_NV,
           Fsaa  : GLRandom.FSAADisabled,
           DblBuf: false,
           Codes : Golden.Crc,
           FbSize: (640*480*4)*(1+1),
         };
      subTests[ numSubTests++ ] =
         {
           Name  : "float64",
           Depth : 32,
           Format: GL_FLOAT_RGBA16_NV,
           Fsaa  : GLRandom.FSAADisabled,
           DblBuf: false,
           Codes : Golden.Crc,
           FbSize: (640*480*8)+(640*480*4),
         };
      subTests[ numSubTests++ ] =
         {
           Name  : "float128",
           Depth : 32,
           Format: GL_FLOAT_RGBA32_NV,
           Fsaa  : GLRandom.FSAADisabled,
           DblBuf: false,
           Codes : Golden.Crc,
           FbSize: (640*480*16)+(640*480*4),
         };
   }
   subTests[ numSubTests++ ] =
      {
        Name  : "2xQx",
        Depth : 32,
        Format: 0,
        Fsaa  : GLRandom.FSAA2xQuincunx,
        DblBuf: true,
        Codes : Golden.CheckSums,
        FbSize: (640*480*4)*(2+2+1+1),
      };
   subTests[ numSubTests++ ] =
      {
        Name  : "4xGs",
        Depth : 32,
        Format: 0,
        Fsaa  : GLRandom.FSAA4xGaussian,
        DblBuf: true,
        Codes : Golden.CheckSums,
        FbSize: (640*480*4)*(4+4+1+1),
      };
   if (DoFOS)
   {
      subTests[ numSubTests++ ] =
         {
           Name  : "2xFOS",
           Depth : 32,
           Format: 0,
           Fsaa  : GLRandom.FSAA2xDac,
           DblBuf: false,
           Codes : Golden.DacCrc,
           FbSize: (640*480*4)*(2+2),
         };
      subTests[ numSubTests++ ] =
         {
           Name  : "2xQxFOS",
           Depth : 32,
           Format: 0,
           Fsaa  : GLRandom.FSAA2xQuincunxDac,
           DblBuf: false,
           Codes : Golden.DacCrc,
           FbSize: (640*480*4)*(2+2),
         };
      subTests[ numSubTests++ ] =
         {
           Name  : "4xFOS",
           Depth : 32,
           Format: 0,
           Fsaa  : GLRandom.FSAA4xDac,
           DblBuf: false,
           Codes : Golden.DacCrc,
           FbSize: (640*480*4)*(4+4),
         };
   }

   // Set up some test controls.
   GLRandom.Golden.SkipCount                   = loopsPerFrame;
   GLRandom.TestConfiguration.RestartSkipCount = loopsPerFrame;
   GLRandom.TestConfiguration.Loops            = framesPerTest * loopsPerFrame;
   GLRandom.Golden.Codes                       = Golden.DacCrc;
   GLRandom.FullScreen                         = true;
   GLRandom.TestConfiguration.DisplayWidth     = 640;
   GLRandom.TestConfiguration.DisplayHeight    = 480;
   if (do_pause)
      GLRandom.Golden.Pause = Golden.OnStore | Golden.OnCheck | Golden.OnSkip;

   Log.Never("GLRandom.Run");

   // Offset the loop-numbers of glr_display away from the loops used
   // by glr_hwtest, to avoid golden-value collisions in the debug
   // self-consistency records.
   var loopOffset = 100000;

   // Loop over each subtest:
   var fbSize = FrameBuffer.GRAPHICS_RAMAMOUNT;
   var rc = 0;
   var subTestIdx;
   for (subTestIdx = 0; subTestIdx < numSubTests; subTestIdx++)
   {
      GLRandom.Golden.Codes                   = subTests[subTestIdx].Codes;
      GLRandom.TestConfiguration.StartLoop    = loopOffset + subTestIdx * framesPerTest * loopsPerFrame;
      GLRandom.TestConfiguration.DisplayDepth = subTests[subTestIdx].Depth;
      GLRandom.TestConfiguration.ZDepth       = subTests[subTestIdx].Depth;
      GLRandom.ColorSurfaceFormat             = subTests[subTestIdx].Format;
      GLRandom.DoubleBuffer                   = subTests[subTestIdx].DblBuf;
      GLRandom.FSAAMode                       = subTests[subTestIdx].Fsaa;

      if ((subTestIdx == 0) ||
          (subTests[subTestIdx-1].Depth != subTests[subTestIdx].Depth))
      {
         GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
         GLRandom.FreeUserFragmentPrograms();
         glr_avoid_software_paths();
         
         GLRandom.Golden.Name = GLRandom.Golden.Name + "dpy";

         GLRandom.SetPicker(RND_GEOM_BBOX_WIDTH,   [ RND_GEOM_WorldWidth/nAcross ]);
         GLRandom.SetPicker(RND_GEOM_BBOX_HEIGHT,  [ RND_GEOM_WorldHeight/nDown  ]);
         GLRandom.SetPicker(RND_GEOM_BBOX_XOFFSET, [ RND_GEOM_WorldWidth/nAcross ]);
         GLRandom.SetPicker(RND_GEOM_BBOX_YOFFSET, [ RND_GEOM_WorldHeight/nDown  ]);
      }
      
      if (GLRandom.CustomerGen)
      {
         glr_mark_golden_recs();
         continue;
      }

      if ((! GLRandom.FSAAModeSupported(subTests[subTestIdx].Fsaa)) ||
          (fbSize - subTests[subTestIdx].FbSize < 2*1024*1024))
      {
         if (do_pause)
            Out.Printf(Out.PriHigh, "Skipping subtest %d (%s)\n",
                  subTestIdx, subTests[subTestIdx].Name);
         continue;
      }

      if (do_pause)
      {
         Out.Printf(Out.PriHigh, "glr_display subtest %d: %s\n",
               subTestIdx, subTests[subTestIdx].Name);
      }
      rc = GLRandom.Run();
      if (rc)
      {
         Out.Printf(Out.PriHigh, "glr_display failed on subtest %s\n",
               subTests[subTestIdx].Name)
         break;
      }
   }

   // Restore the test controls we messed with.
   Log.OnError("GLRandom.Run");
   GLRandom.Golden.SkipCount                = oldDrawsPerFrame;
   GLRandom.Golden.Codes                    = oldGoldenCodes;
   GLRandom.TestConfiguration.DisplayWidth  = oldTcWidth;
   GLRandom.TestConfiguration.DisplayHeight = oldTcHeight;
   GLRandom.TestConfiguration.DisplayDepth  = oldTcDepth;
   GLRandom.ColorSurfaceFormat              = oldColorSurfaceFormat;
   GLRandom.TestConfiguration.ZDepth        = oldTcZDepth;
   GLRandom.TestConfiguration.Loops         = oldTcLoops;
   GLRandom.TestConfiguration.StartLoop     = 0;
   GLRandom.TestConfiguration.RestartSkipCount = oldDrawsPerFrame;
   GLRandom.FullScreen                      = oldFullScreen;
   GLRandom.DoubleBuffer                    = oldDoubleBuffer;
   GLRandom.FSAAMode                        = oldFSAAMode;

   return rc;
}

//------------------------------------------------------------------------------
// When we are in the process of separating out the golden records for
// the customer version of the diag, use this function to mark the appropriate
// loops for GLRandom.
function glr_mark_golden_recs()
{
   var skip = Golden.SkipCount;
   if (undefined != GLRandom.Golden.SkipCount)
      skip = GLRandom.Golden.SkipCount;
   if (skip == 0)
      skip = 1;
      
   var startLoop = TestConfiguration.StartLoop;
   if (undefined != GLRandom.TestConfiguration.StartLoop)
      startLoop = GLRandom.TestConfiguration.StartLoop;
      
   var loops = TestConfiguration.Loops;
   if (undefined != GLRandom.TestConfiguration.Loops)
      loops = GLRandom.TestConfiguration.Loops;

   var loop;
   for (loop = startLoop; loop < startLoop + loops; loop += skip)
   {
      Golden.MarkRecs("GLRandom", loop + skip - 1);
   }
   return 0;
}

//------------------------------------------------------------------------------
// Progressive-test
//
// Test the 3d hardware, progressively turning on more and more features
// with each frame (i.e. restart-point loop).
// On failure, the last loop completed should give us a clue about what
// part of the chip is bad.
//
// Designed to hit "everything enabled" mode eventually, and test
// everything at once from there on out.
//
var glr_progressive_framesPerState = 1;

function glr_progressive_updater()
{
   // Where are we in the sequence now?
   // Note: state 0 is special, so subtract framesPerState in calculating item and OnMix.

   var framesPerState = glr_progressive_framesPerState;

   var Frame = Math.floor(GLRandom.Loop / GLRandom.TestConfiguration.RestartSkipCount);
   var item  = Math.floor((Frame - framesPerState) / (2*framesPerState));
   var OnMix = Math.floor((Frame - framesPerState - (2*framesPerState*item)) / framesPerState);

   var numFrames = (1 + 2*glr_progressive.PickerUpdateListLength)*framesPerState;
   var i;

   if (item > glr_progressive.PickerUpdateListLength)
      item = glr_progressive.PickerUpdateListLength;

   // All the items after the current item should be set to "off".
   for (i = item + 1; i < glr_progressive.PickerUpdateListLength; i++)
   {
      GLRandom.SetPicker(  glr_progressive.PickerUpdateList[i].index,
                           glr_progressive.PickerUpdateList[i].off );
   }

   // All the items before the current item should be set to "mix".
   for (i = 0; i < item; i++)
   {
      GLRandom.SetPicker(  glr_progressive.PickerUpdateList[i].index,
                           glr_progressive.PickerUpdateList[i].mix );
   }

   // Set the current item.
   if (Frame < framesPerState)
   {
      glr_progressive.Mode = "everything off";
   }
   else if (item >= glr_progressive.PickerUpdateListLength)
   {
      glr_progressive.Mode = "everything on";

      // No need to call this update routine anymore.
      GLRandom.SetPicker(RND_TSTCTRL_STOP, [ GL_FALSE ]);
   }
   else if (OnMix == 0)
   {
      glr_progressive.Mode =
         Out.Sprintf("%s on",glr_progressive.PickerUpdateList[item].name);

      GLRandom.SetPicker(  glr_progressive.PickerUpdateList[item].index,
                           glr_progressive.PickerUpdateList[item].on );
   }
   else
   {
      glr_progressive.Mode =
         Out.Sprintf("%s mix", glr_progressive.PickerUpdateList[item].name);

      GLRandom.SetPicker(  glr_progressive.PickerUpdateList[item].index,
                           glr_progressive.PickerUpdateList[item].mix );
   }

   Out.Printf(Out.PriNormal, "\nFrame %d of %d: %s\n", Frame, numFrames, glr_progressive.Mode);
   return 0;
}

function glr_progressive()
{
   // First, get our baseline for "everything on" mode.
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_avoid_software_paths();

   // Set the "stop" picker (which always picks first) to be our function
   // for updating all the other pickers.
   GLRandom.SetPicker(RND_TSTCTRL_STOP, ["js", "PickOnRestart", glr_progressive_updater]);


   // Set up the on/off/mixed mode picker data we will use later.

   glr_progressive.PickerUpdateList = new Object;
   var Length = 0;

   var DeviceId = Gpu.PciDeviceId;
   var Caps     = [];
   NvRm.ConfigGet(NV_CFG_GRAPHICS_CAPS, Caps);

   if (DeviceId >= 0x200)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "PolyStip",
            index:   RND_PRIM_POLY_STIPPLE_ENABLE,
            off:     [ GL_FALSE ],
            on:      [ "list", GL_TRUE, GL_FALSE ],
            mix:     GLRandom.GetPicker(RND_PRIM_POLY_STIPPLE_ENABLE)
         };
   }
   if (DeviceId >= 0x300)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "LineStip",
            index:   RND_PRIM_LINE_STIPPLE_ENABLE,
            off:     [ GL_FALSE ],
            on:      [ "list", GL_TRUE, GL_FALSE ],
            mix:     GLRandom.GetPicker(RND_PRIM_LINE_STIPPLE_ENABLE)
         };
   }
   if (GLRandom.TestConfiguration.DisplayDepth == 32)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "AlphaTest",
            index:   RND_FRAG_ALPHA_FUNC,
            off:     [ GL_FALSE ],
            on:      [ "list", GL_LESS, GL_ALWAYS, GL_NOTEQUAL, GL_LEQUAL, GL_GEQUAL, GL_GREATER, GL_EQUAL, GL_NEVER ],
            mix:     GLRandom.GetPicker(RND_FRAG_ALPHA_FUNC)
         };
   }
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "Blend",
         index:   RND_FRAG_BLEND_EQN,
         off:     [ GL_FALSE ],
         on:      [ "list", GL_FALSE, GL_FUNC_ADD_EXT, GL_MAX_EXT, GL_MIN_EXT, GL_FUNC_SUBTRACT_EXT, GL_FUNC_REVERSE_SUBTRACT_EXT ],
         mix:     GLRandom.GetPicker(RND_FRAG_BLEND_EQN)
      };
   if(Caps[0] & NV_CFG_GRAPHICS_CAPS_LOGIC_OPS)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "ColorLogicOp",
            index:   RND_FRAG_LOGIC_OP,
            off:     [ GL_FALSE ],
            on:      [ "list", GL_COPY, GL_CLEAR, GL_SET, GL_COPY_INVERTED, GL_NOOP, GL_INVERT, GL_AND, GL_NAND, GL_OR, GL_NOR, GL_XOR, GL_EQUIV, GL_AND_REVERSE, GL_AND_INVERTED, GL_OR_REVERSE, GL_OR_INVERTED ],
            mix:     GLRandom.GetPicker(RND_FRAG_LOGIC_OP)
         };
   }
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "Z",
         index:   RND_FRAG_DEPTH_FUNC,
         off:     [ GL_FALSE ],
         on:      [ "list", GL_LESS, GL_ALWAYS, GL_NOTEQUAL, GL_LEQUAL, GL_GEQUAL, GL_GREATER, GL_EQUAL, GL_NEVER ],
         mix:     GLRandom.GetPicker(RND_FRAG_DEPTH_FUNC)
      };
   if (GLRandom.TestConfiguration.ZDepth == 32)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "Stencil",
            index:   RND_FRAG_STENCIL_FUNC,
            off:     [ GL_FALSE ],
            on:      [ "list", GL_LESS, GL_ALWAYS, GL_NOTEQUAL, GL_LEQUAL, GL_GEQUAL, GL_GREATER, GL_EQUAL, GL_NEVER ],
            mix:     GLRandom.GetPicker(RND_FRAG_STENCIL_FUNC)
         };
   }
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "Fog",
         index:   RND_FOG_ENABLE,
         off:     [ GL_FALSE ],
         on:      [ GL_TRUE ],
         mix:     GLRandom.GetPicker(RND_FOG_ENABLE)
      };
   if (DeviceId >= 0x100)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "Lighting",
            index:   RND_LIGHT_ENABLE,
            off:     [ GL_FALSE ],
            on:      [ GL_TRUE ],
            mix:     GLRandom.GetPicker(RND_LIGHT_ENABLE)
         };
   }
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "Txu0",
         index:   RND_TXU_ENABLE_MASK,
         off:     [ 0 ],
         on:      [ 1 ],
         mix:     [ "random", [1, 0], [1, 1]]
      };
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "Txu1",
         index:   RND_TXU_ENABLE_MASK,
         off:     [ 0 ],
         on:      [ 2 ],
         mix:     GLRandom.GetPicker(RND_TXU_ENABLE_MASK)
      };
   if (DeviceId >= 0x100)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "TxCoordGen",
            index:   RND_GEOM_TXU_GEN_ENABLED,
            off:     [ GL_FALSE ],
            on:      [ GL_TRUE ],
            mix:     GLRandom.GetPicker(RND_GEOM_TXU_GEN_ENABLED)
         };
   }
   if (DeviceId >= 0x100)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "Aniso",
            index:   RND_TXU_MAX_ANISOTROPY,
            off:     [ "float", 1.0 ],
            on:      [ "float", 8.0 ],
            mix:     GLRandom.GetPicker(RND_TXU_MAX_ANISOTROPY)
         };
   }
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "TextureDim",
         index:   RND_TX_DIM,
         off:     [ GL_TEXTURE_2D ],
         on:      [ "list", GL_TEXTURE_2D, GL_TEXTURE_3D, GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_1D, GL_TEXTURE_RECTANGLE_NV ],
         mix:     GLRandom.GetPicker(RND_TX_DIM)
      };
   if (DeviceId >= 0x100)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "TxMatrix",
            index:   RND_GEOM_TXMX_OPERATION,
            off:     [ RND_GEOM_TXMX_OPERATION_Identity ],
            on:      [ RND_GEOM_TXMX_OPERATION_2dRotate, RND_GEOM_TXMX_OPERATION_2dTranslate, RND_GEOM_TXMX_OPERATION_2dScale, RND_GEOM_TXMX_OPERATION_2dAll, RND_GEOM_TXMX_OPERATION_Project ],
            mix:     GLRandom.GetPicker(RND_GEOM_TXMX_OPERATION)
         };
   }
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "TextureFormat",
         index:   RND_TX_INTERNAL_FORMAT,
         off:     [ GL_RGBA ],
         on:      [ "list", 1, 2, GL_RGB, GL_RGBA, GL_ALPHA, GL_LUMINANCE, GL_LUMINANCE_ALPHA, GL_INTENSITY, GL_COMPRESSED_RGB_S3TC_DXT1_EXT, GL_COMPRESSED_RGBA_S3TC_DXT1_EXT, GL_COMPRESSED_RGBA_S3TC_DXT3_EXT, GL_COMPRESSED_RGBA_S3TC_DXT5_EXT, GL_COLOR_INDEX8_EXT, GL_SIGNED_RGBA_NV, GL_SIGNED_RGB_NV, GL_SIGNED_LUMINANCE_NV, GL_SIGNED_LUMINANCE_ALPHA_NV, GL_SIGNED_ALPHA_NV, GL_SIGNED_INTENSITY_NV, GL_SIGNED_RGB_UNSIGNED_ALPHA_NV, GL_HILO_NV, GL_SIGNED_HILO_NV, GL_DSDT_NV, GL_DSDT_MAG_NV, GL_DSDT_MAG_INTENSITY_NV ],
         mix:     GLRandom.GetPicker(RND_TX_INTERNAL_FORMAT)
      };
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "Mipmapping",
         index:   RND_TX_MAX_MM,
         off:     [ 0 ],
         on:      [ 100 ],
         mix:     GLRandom.GetPicker(RND_TX_MAX_MM)
      };
   if (DeviceId >= 0x100)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "Combiners",
            index:   RND_CMB_THEME,
            off:     [ RND_CMB_THEME_Disabled ],
            on:      [ RND_CMB_THEME_Random ],
            mix:     GLRandom.GetPicker(RND_CMB_THEME)
         };
   }
   if (DeviceId >= 0x200)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "TxShader",
            index:   RND_TX_SHADER_ENABLE,
            off:     [ GL_FALSE ],
            on:      [ GL_TRUE ],
            mix:     GLRandom.GetPicker(RND_TX_SHADER_ENABLE)
         };
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "VxProg",
            index:   RND_GEOM_VXPGM_ENABLE,
            off:     [ GL_FALSE ],
            on:      [ GL_TRUE ],
            mix:     GLRandom.GetPicker(RND_GEOM_VXPGM_ENABLE)
         };
   }
   if (DeviceId >= 0x300)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "FrProg",
            index:   RND_TX_FRAG_PROG_ENABLE,
            off:     [ GL_FALSE ],
            on:      [ GL_TRUE ],
            mix:     GLRandom.GetPicker(RND_TX_FRAG_PROG_ENABLE)
         };
   }
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "VxArrays",
         index:   RND_VX_SEND_METHOD,
         off:     [ RND_VX_SEND_METHOD_Immediate ],
         on:      [ RND_VX_SEND_METHOD_DrawElements ],
         mix:     GLRandom.GetPicker(RND_VX_SEND_METHOD)
      };
   glr_progressive.PickerUpdateList[ Length++ ] =
      {
         name:    "VxArrays_FB",
         index:   RND_VX_MEMORY_TYPE,
         off:     [ "random", [1, Memory.Pci] ],
         on:      [ "random", [1, Memory.Fb] ],
         mix:     GLRandom.GetPicker(RND_VX_MEMORY_TYPE)
      };
   if (DeviceId >= 0x300)
   {
      glr_progressive.PickerUpdateList[ Length++ ] =
         {
            name:    "UsrClip",
            index:   RND_GEOM_USER_CLIP_PLANE_MASK,
            off:     [ 0 ],
            on:      [ 0xff ],
            mix:     GLRandom.GetPicker(RND_GEOM_USER_CLIP_PLANE_MASK)
         };
   }

   glr_progressive.PickerUpdateListLength = Length;
}
function glr_pro(framesPerState, firstLoop, lastLoop)
{
   //
   // Argument: framesPerState, default 1
   //
   if ((undefined == framesPerState) || (1 > framesPerState))
      glr_progressive_framesPerState = 1;
   else
      glr_progressive_framesPerState = framesPerState;

   //
   // Argument: firstLoop, default 0
   //
   if ((undefined == firstLoop) || (0 > firstLoop))
      firstLoop = 0;

   //
   // Argument: lastLoop, default (firstLoop + Loops)
   //
   if ((undefined == lastLoop) || (firstLoop > lastLoop))
   {
      if (undefined == GLRandom.TestConfiguration.Loops)
         GLRandom.TestConfiguration.Loops = TestConfiguration.Loops;

      lastLoop = firstLoop + GLRandom.TestConfiguration.Loops - 1;
   }

   //
   // Set GLRandom controls (FancyPickers, aka probability tables)
   //
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_progressive();
   glr_isolate(firstLoop, lastLoop);

   //
   // Force us to use a different Golden database key than glr_hwtest
   // does, even though both are based on the GLRandom test.
   //
   GLRandom.Golden.Name = GLRandom.Golden.Name + "prog";

   //
   // Run the test.
   //
   if (GLRandom.CustomerGen)
      return glr_mark_golden_recs();
      
   var rc = GLRandom.Run();

   //
   // Report errors.
   //
   if (rc)
   {
      Out.Printf(Out.PriHigh, "\nglr_pro failed at loop %d frame %d: %s\n",
            GLRandom.Loop,
            Math.floor(GLRandom.Loop / GLRandom.TestConfiguration.RestartSkipCount),
            glr_progressive.Mode);
      glr_print_miscompare_details();
   }
   return rc;
}

function glr_pro10()
{
   Log.Never("glr_pro");

   //
   // Figure out how many loops to run.
   // Call glr_progressive to find out how many features/states we can use
   // on this nvidia chip.
   // The whole run is:  (numFeatures*2 + 1) * framesPerState * drawsPerFrame
   //
   var OldLoops      = GLRandom.TestConfiguration.Loops;
   var OldStartLoop  = GLRandom.TestConfiguration.StartLoop;

   glr_progressive();
   GLRandom.TestConfiguration.Loops =
            ((glr_progressive.PickerUpdateListLength * 2) + 1) *
            10 *
            GLRandom.TestConfiguration.RestartSkipCount;

   GLRandom.Golden.StopOnError = false;
   GLRandom.Golden.PrintCsv = true;
   //GLRandom.Golden.DumpTga = Golden.OnError;

   //
   // If you wanted to restrict the test to just one frame,
   // i.e. the frame containing draws 19000 to 19499,
   // uncomment and edit the following line:
   //
   // var rc = glr_pro(10, 19000, 19499);
   //
   var rc = glr_pro(10);

   //
   // Restore global variables to previous values, return our result code.
   //
   GLRandom.TestConfiguration.Loops       = OldLoops;
   GLRandom.TestConfiguration.StartLoop   = OldStartLoop;

   GLRandom.Golden.StopOnError = true;
   GLRandom.Golden.PrintCsv = false;

   return rc;
}

//------------------------------------------------------------------------------
// glr_ctxsw -- OpenGL Random Context-Switching Test
//
// This is just the plain old glr_hwtest script, but we also run
// the resman's 3d stress test in a background thread, offscreen.
//
// This heavily exercises the ability of the GPU and resman to 
// switch between different graphics contexts.
//
// This is an engineering test, for detecting HW design flaws or resman bugs.
//
function glr_ctxsw_bgthread()
{
   // Background thread: run a version of the resman's 3d stress test.
   // The stress test only works on nv3x, on internal mods builds.
   if ((Gpu.DeviceId >= Gpu.NV30) && !Official)
   {
      Class3097.TestConfiguration               = new Object;
      Class3097.TestConfiguration.DisplayWidth  = 640;
      Class3097.TestConfiguration.DisplayHeight = 480;
      Class3097.TestConfiguration.Loops         = 1;
      Class3097.SkipModeset                     = true;
      Class3097.KeepRunning                     = true;

      Class3097.Run();
   
   }
   return OK;
}

function glr_ctxsw_ena_ui_callback()
{
   // This is called before the final modeswitch back to VGA text mode,
   // when GLRandom exits.
   // The Class3097 test must be allowed to exit cleanly before this 
   // modeswitch, or it will get notifier timeouts.
   
   if (!Official)
      Class3097.KeepRunning = false;
   
   Sleep(250);
   return OK;
}

function glr_ctxsw()
{
   // We must be in graphics mode before Class3097 starts.
   // @@@ For non-DOS platforms, this is probably broken, but we can't
   //     fix the problem until DisableUserInterface is nestable.
   Display.SetMode(640,480,32,60);
   
   // Start the background 3d stress task.
   var bgThreadId = Tasker.CreateThread("bg3dStress", glr_ctxsw_bgthread);
   Sleep(250);
   
   // Run the foreground random GL 3d test.
   EnableUserInterfaceCallback = glr_ctxsw_ena_ui_callback;
   var rc = glr_hwtest();
   EnableUserInterfaceCallback = undefined;
      
   // Clean up the background thread.
   if (bgThreadId)
   {
      if (!Official)
      {
         // Just in case the enable-user-interface-callback didn't do this...
         Class3097.KeepRunning = false;
      }
      Tasker.Join(bgThreadId);
   }
   
   return rc;
}

//------------------------------------------------------------------------------
#ifndef TM_OQA
#define TM_OQA    (1 << 0)
#define TM_GPU    (1 << 1)
#define TM_ENGR   (1 << 2)
#endif

//------------------------------------------------------------------------------
function glr_shmoo_setup(testmode, runonerr)
{
   GLRandom.TestConfiguration.DisplayWidth       =  1024;
   GLRandom.TestConfiguration.DisplayHeight      =   768;
   GLRandom.TestConfiguration.DisplayDepth       =    32;
   GLRandom.TestConfiguration.DisplayRefreshRate =    60;
   GLRandom.Golden.Codes                         = Golden.CheckSums;
   GLRandom.Golden.NumCodeBins                   = 97;

   GLRandom.FrameRetries = 10;

   if (undefined == testmode)
      testmode = TM_GPU;

   if (runonerr)
   {
      GLRandom.ContinueOnFrameError = true;
      GLRandom.FrameRetries         = 0;
   }

   switch (testmode)
   {
      case TM_OQA:
      {
         GLRandom.Golden.TestMode            = Golden.Oqa;
         GLRandom.AllowedSoftErrors          = 2;
         Golden.AllowedBadBinsOneCheck       = undefined;
         Golden.AllowedSumDiffOneCheck       = undefined;
         GLRandom.TestConfiguration.Loops    = 5000;
         break;
      } // TM_OQA

      case TM_GPU:
      {
         GLRandom.Golden.TestMode            = Golden.Mfg;
         GLRandom.AllowedSoftErrors          = 1;
         Golden.AllowedBadBinsOneCheck       = undefined;
         Golden.AllowedSumDiffOneCheck       = undefined;
         GLRandom.TestConfiguration.Loops    = 15000;
         break;
      } // TM_GPU

      case TM_ENGR:
      {
         Golden.TestMode                     = Golden.Mfg;
         GLRandom.AllowedSoftErrors          = 0;
         Golden.AllowedBadBinsOneCheck       = 0;
         Golden.AllowedSumDiffOneCheck       = [0, 0, 0, 0, 0, 0];
         GLRandom.TestConfiguration.Loops    = 30000;
         break;
      } // TM_ENGR
   }

   gfname = "golden" + Out.Sprintf("%02x", Gpu.DeviceId) + ".bin";

   Golden.Name   = Out.Sprintf("%s_NV%02X", OperatingSystem, Gpu.DeviceId);
   Golden.Action = Golden.Check;

   return Golden.ReadFile(gfname, Out.LevLow);
}

//------------------------------------------------------------------------------
function glr_shmoowrap()
{
   // Run the test.
   glr_hwtest();

   // Return the number of frames bad out of the total number attempted.
   //
   //   ENGR will attempt 60
   //   MFG will attempt 30
   //   OEM will attempt 10
   //
   // If the glr_shmoo_setup "runonerr" argument was 1, all frames will be tried.
   // Otherwise, glr_hwtest will stop on failure, and this function will always
   // return between 1 and 3.

   var FrameErrs = GLRandom.GetFrameErrCounts();

   //           soft           mixed          hard
   var errate = FrameErrs[1] + FrameErrs[2] + FrameErrs[3];

   // If a hang occurred, return 1000.
   if (FrameErrs[4] > 0)
      errate = 1000;

   return errate;
}

//------------------------------------------------------------------------------
// Test 3d in 32, 16 bit and one FSAA mode.
//
function glr_super()
{
   if (undefined == GLRandom.TestConfiguration.StartLoop)
      GLRandom.TestConfiguration.StartLoop = TestConfiguration.StartLoop;
   if (undefined == GLRandom.TestConfiguration.Loops)
      GLRandom.TestConfiguration.Loops = TestConfiguration.Loops;

   // Put things back...
   var OrigStart  = GLRandom.TestConfiguration.StartLoop;
   var OrigLoops  = GLRandom.TestConfiguration.Loops;
   var OrigDepth  = GLRandom.TestConfiguration.DisplayDepth;
   var OrigZDepth = GLRandom.TestConfiguration.ZDepth
   var OrigFsaa   = GLRandom.FSAAMode;
   var OrigDBuf   = GLRandom.DoubleBuffer;

   var SubTests =
   [
      {
        Name  : "progressive 32bpp",
        Loops : 25000,
        Depth : 32,
        Fsaa  : GLRandom.FSAADisabled,
        Func  : glr_pro
      },
      {
        Name  : "16bpp",
        Loops :  8000,
        Depth : 16,
        Fsaa  : GLRandom.FSAADisabled,
        Func  : glr_hwtest
      },
      {
        Name  : "FSAA 32bpp",
        Loops : 17000,
        Depth : 32,
        Fsaa  : GLRandom.FSAA2x,
        Func  : glr_hwtest
      },
   ];
   var NumSubTests = 3;
   switch (Gpu.PciDeviceId >> 4)
   {
      case 0x020:      // GeForce3
      case 0x017:      // marketing name TBD
      case 0x025:
         SubTests[2].Fsaa = GLRandom.FSAA2xQuincunx;
         break;

      case 0x02A:      // xbox
         SubTests[2].Fsaa = GLRandom.FSAA4xGaussian;
         break;

      default:         // all others: tnt, geforce, geforce 2, etc.
         SubTests[2].Fsaa = GLRandom.FSAADisabled;
         break;
   }

   //
   // Call subtests over and over until we consume all loops.
   //
   var rc;
   var doneLoops = 0;

   while (doneLoops < (OrigStart + OrigLoops))
   {
      var subIdx;
      for (subIdx = 0; subIdx < NumSubTests; subIdx++)
      {
         //
         // In case OrigStart is > 0, we might not run all the loops in this
         // subtest.  In fact, we might skip over this subtest entirely.
         //
         var skipLoops  = OrigStart - doneLoops;
         if (skipLoops < 0)
            skipLoops = 0;
         if (skipLoops > SubTests[subIdx].Loops)
            skipLoops = SubTests[subIdx].Loops;

         var subLoops = OrigStart + OrigLoops - doneLoops;
         if (subLoops > SubTests[subIdx].Loops)
            subLoops = SubTests[subIdx].Loops;

         doneLoops += skipLoops;
         subLoops  -= skipLoops;

         if (subLoops > 0)
         {
            Out.Printf(Out.PriLow, "%s from %d to %d\n", SubTests[subIdx].Name, doneLoops, doneLoops + subLoops);

            GLRandom.TestConfiguration.DisplayDepth   = SubTests[subIdx].Depth;
            GLRandom.TestConfiguration.ZDepth         = SubTests[subIdx].Depth;
            GLRandom.FSAAMode                         = SubTests[subIdx].Fsaa;
            if (GLRandom.FSAAMode == GLRandom.FSAADisabled)
            {
               GLRandom.DoubleBuffer                  = false;
               GLRandom.SetDefaultPicker(RND_TSTCTRL_FLUSH);
            }
            else
            {
               GLRandom.DoubleBuffer                  = true;
               GLRandom.SetPicker(RND_TSTCTRL_FLUSH, [GL_FALSE]);
            }
            GLRandom.TestConfiguration.StartLoop      = doneLoops;
            GLRandom.TestConfiguration.Loops          = subLoops;

            rc = SubTests[subIdx].Func();
            if (rc)
            {
               Out.Printf(Out.PriHigh, "\nglr_super %s failed at loop %d (%s) diffs: %d %d %d %d %d %d (argbsd)\n\n",
                     SubTests[subIdx].Name,
                     GLRandom.Loop,
                     (subIdx == 0) ? glr_progressive.Mode : "everything on",
                     GLRandom.Golden.TotalCheckSumDiffs[0],
                     GLRandom.Golden.TotalCheckSumDiffs[1],
                     GLRandom.Golden.TotalCheckSumDiffs[2],
                     GLRandom.Golden.TotalCheckSumDiffs[3],
                     GLRandom.Golden.TotalCheckSumDiffs[4],
                     GLRandom.Golden.TotalCheckSumDiffs[5] );
               if (!g_RunOnError)
                  break;
            }
            doneLoops += subLoops;
         }
      }
      if (rc && !g_RunOnError)
         break;
   }

   // Restore settings.
   GLRandom.TestConfiguration.StartLoop      = OrigStart;
   GLRandom.TestConfiguration.Loops          = OrigLoops;
   GLRandom.TestConfiguration.DisplayDepth   = OrigDepth;
   GLRandom.TestConfiguration.ZDepth         = OrigZDepth;
   GLRandom.FSAAMode                         = OrigFsaa;
   GLRandom.DoubleBuffer                     = OrigDBuf;

   return rc;
}

//------------------------------------------------------------------------------
// Run N million draws and see if we get matching CRC's.
//
function glr_repeatability(numRuns, setupFunc, badRun, dumpTgas, chkPerDraw, isolateLoop)
{
   var rc;
   //
   // Control constants (edit here to change):
   //
   var lpf            = 500;      // loops per frame
   var fpr            = 1;        // frames per run
   var checksPerStore = 1;        // number of check runs per store run
   var sloppy         = false;    // if true, ignore some bad pixels
   var reorder        = false;    // if true, run the check frames in reverse order, to catch software restartability bugs.

   GLRandom.TestConfiguration.UseTiledSurface   = true;
   if (Gpu.PciDeviceId < 0x0100)
      GLRandom.PrintOnSwDispatch                = false
   else
      GLRandom.PrintOnSwDispatch                = true;

   GLRandom.TestConfiguration.DisplayWidth      = 1024;
   GLRandom.TestConfiguration.DisplayHeight     =  768;
   if (Gpu.DeviceId == Gpu.NV2A)
   {
      GLRandom.TestConfiguration.DisplayWidth      = 640;
      GLRandom.TestConfiguration.DisplayHeight     = 480;
   }
   if (Ikos)
   {
      lpf = 125;
      fpr = 50;
      GLRandom.TestConfiguration.DisplayWidth      = 640;
      GLRandom.TestConfiguration.DisplayHeight     = 480;
   }
   GLRandom.TestConfiguration.RestartSkipCount  = lpf;
   GLRandom.Golden.SkipCount                    = lpf;
   GLRandom.Golden.Codes                        = Golden.CheckSums;
   GLRandom.Golden.NumCodeBins                  = 97;
   GLRandom.AllowedSoftErrors                   = 0;
   GLRandom.FrameRetries                        = 0;


   //
   // Function arguments, set defaults for unspecified args:
   //
   if (undefined == numRuns)
      numRuns = 1;

   if (undefined == setupFunc)
      setupFunc = glr_avoid_software_paths;

   if (undefined == badRun)
      badRun = -1;

   if (undefined == dumpTgas)
      dumpTgas = false;

   if (undefined == chkPerDraw)
      chkPerDraw = false;

   if (undefined == isolateLoop)
      isolateLoop = -1;


   //
   // Set up control variables for GLRandom:
   //
   if (sloppy)
   {
      GLRandom.Golden.StopOnError               = false;
      GLRandom.Golden.AllowedBadBinsOneCheck    = 100;
      GLRandom.Golden.AllowedSumDiffOneCheck    = [ 25500, // alpha
                                                    25500, // red
                                                    25500, // green
                                                    25500, // blue
                                                    25500, // stencil
                                                    255000000  // depth
                                                  ];
   }
   else
   {
      GLRandom.Golden.StopOnError               = true;
      GLRandom.Golden.AllowedBadBinsOneCheck    = 0;
      GLRandom.Golden.AllowedSumDiffOneCheck    = [ 0, // alpha
                                                    0, // red
                                                    0, // green
                                                    0, // blue
                                                    0, // stencil
                                                    0  // depth
                                                  ];
   }
   GLRandom.SuperVerbose                        = false;
   GLRandom.Golden.Pause                        = Golden.Never;
   GLRandom.Golden.TgaAlphaToRgb                = false;
   GLRandom.TestConfiguration.StartLoop         = 0;

   //
   // Loop for each run:
   //
   if (badRun > 0)
      beginRun = badRun-1;
   else
      beginRun = 0;

   endRun = beginRun + numRuns;

   for(run = beginRun; run < endRun; run++)
   {
      // Seed:
      GLRandom.TestConfiguration.Seed  = run * lpf * fpr + TestConfiguration.Seed;

      //
      // Store:
      //
      Out.Printf(Out.PriHigh, "Run %-2d Seed %-4x %dx%d store..",
            run,
            GLRandom.TestConfiguration.Seed,
            fpr, lpf );

      GLRandom.Golden.ForceErrorLoop = 0;
      GLRandom.Golden.ForceErrorMask = 0;

      if (reorder)
      {
         fbegin = fpr-1;
         fend   = -1;
         fincr  = -1;
      }
      else
      {
         fbegin = 0;
         fend   = fpr;

         if ((run == badRun) && (isolateLoop >= 0))
            fincr  = 1;
         else
            fincr  = fpr;
      }
      for (frame = fbegin; frame != fend; frame += fincr)
      {
         //LevNormal();
         GLRandom.SuperVerbose      = false;
         GLRandom.Golden.Action     = Golden.Store;
         GLRandom.Golden.DumpTga    = Golden.Never;
         GLRandom.Golden.Pause      = Golden.Never;
         GLRandom.Golden.Print      = Golden.Never;
         GLRandom.Golden.SkipCount  = lpf;
         GLRandom.TestConfiguration.StartLoop   = frame * lpf;
         GLRandom.TestConfiguration.Loops       = lpf * fincr;
         if (fincr < 0)
            GLRandom.TestConfiguration.Loops *= -1;


         GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
         GLRandom.FreeUserFragmentPrograms();
         setupFunc();   // GLRandom probability tables are set up here.

         if (run == badRun)
         {
            if (dumpTgas)
            {
               GLRandom.Golden.DumpTga    = Golden.OnStore;
               GLRandom.Golden.TgaName    = "St";
            }
            if (chkPerDraw)
            {
               GLRandom.Golden.SkipCount = 0;
            }
            if ((isolateLoop >= GLRandom.TestConfiguration.StartLoop) &&
                (isolateLoop <  GLRandom.TestConfiguration.StartLoop + GLRandom.TestConfiguration.Loops))
            {
               numToSkip = isolateLoop - GLRandom.TestConfiguration.StartLoop - 1;
               GLRandom.SetPicker(RND_TSTCTRL_SKIP,
                     ["list", [numToSkip, 1], [1, 0]] );

               if (isolateLoop > 0)
                  GLRandom.Golden.SkipCount  = isolateLoop+1;
               else
                  GLRandom.Golden.SkipCount  = 0;
               GLRandom.TestConfiguration.Loops = isolateLoop+1 - GLRandom.TestConfiguration.StartLoop;
               GLRandom.Golden.TgaName    = "Si";
               GLRandom.Golden.Pause      = Golden.OnStore;
               GLRandom.Golden.Print      = Golden.OnStore;
            }
         }
         if (0 != (rc = GLRandom.Run()))
            break;
      }
      if (0 != rc)
         break;

      if (!checksPerStore)
         Out.Printf(Out.PriHigh, "\n");
      //
      // Check:
      //
      for (checkRun = 0; checkRun < checksPerStore; checkRun++)
      {
         //GLRandom.Golden.ForceErrorLoop = 750;
         //GLRandom.Golden.ForceErrorMask = 0xffffffff;

         if (checkRun == 0)
         {
            Out.Printf(Out.PriHigh, "check.." );
         }
         else
         {
            Out.Printf(Out.PriHigh, "    %-2d      %-4x %dx%d        check..",
                  run,
                  GLRandom.TestConfiguration.Seed,
                  fpr, lpf );
         }

         //LevNormal();
         GLRandom.SuperVerbose      = false;
         GLRandom.Golden.Action     = Golden.Check;
         GLRandom.Golden.DumpTga    = Golden.Never;
         GLRandom.Golden.Print      = Golden.Never;
         GLRandom.Golden.Pause      = Golden.Never;
         GLRandom.Golden.StopOnError = true;
         GLRandom.Golden.SkipCount  = lpf;
         GLRandom.TestConfiguration.StartLoop   = 0;
         GLRandom.TestConfiguration.Loops       = lpf * fpr;

         if (run == badRun)
         {
            if (dumpTgas)
            {
               GLRandom.Golden.DumpTga    = Golden.OnBadPixel;
               GLRandom.Golden.TgaName    = "Ch";
            }
            if (chkPerDraw)
            {
               GLRandom.Golden.SkipCount     = 0;
               GLRandom.Golden.Print         = Golden.OnBadPixel;
               GLRandom.Golden.StopOnError   = false;
               GLRandom.Golden.Pause         = Golden.OnBadPixel;
            }
            if ((isolateLoop >= GLRandom.TestConfiguration.StartLoop) &&
                (isolateLoop <  GLRandom.TestConfiguration.StartLoop + GLRandom.TestConfiguration.Loops))
            {
               numToSkip = isolateLoop - GLRandom.TestConfiguration.StartLoop - 1;
               GLRandom.SetPicker(RND_TSTCTRL_SKIP,
                     ["list", [numToSkip, 1], [1, 0]] );
               if (isolateLoop > 0)
                  GLRandom.Golden.SkipCount  = isolateLoop+1;
               else
                  GLRandom.Golden.SkipCount  = 0;
               GLRandom.TestConfiguration.Loops = isolateLoop+1 - GLRandom.TestConfiguration.StartLoop;
               GLRandom.Golden.TgaName    = "Ci";
               GLRandom.Golden.Pause      = Golden.OnCheck;
               GLRandom.Golden.Print      = Golden.OnCheck;
               GLRandom.Golden.StopOnError = false;
            }
         }
         
         GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
         GLRandom.FreeUserFragmentPrograms();
         setupFunc();   // GLRandom probability tables are set up here.

         rc = GLRandom.Run();

         Out.Printf(Out.PriHigh, " err/chk: %d/%d diffs: %d %d %d %d %d %d\n",
               GLRandom.Golden.TotalBinMiscompares,
               GLRandom.Golden.ChecksCompleted,
               GLRandom.Golden.TotalCheckSumDiffs[0],
               GLRandom.Golden.TotalCheckSumDiffs[1],
               GLRandom.Golden.TotalCheckSumDiffs[2],
               GLRandom.Golden.TotalCheckSumDiffs[3],
               GLRandom.Golden.TotalCheckSumDiffs[4],
               GLRandom.Golden.TotalCheckSumDiffs[5] );
         if (0 != rc)
            break;
      }
      if (0 != rc)
         break;
   }
   return rc;
}
Log.Always("glr_repeatability");

glrr = glr_repeatability;           // save typing

//------------------------------------------------------------------------------
function glr_replog
(
   setupFunc,     // the test we are attempting repeatability study of
   lpf,           // loops per frame
   cps,           // checks per store
   numRuns,       // number of runs
   beginRun       // starting run
)
{
   if (undefined == setupFunc)
      setupFunc = glr_avoid_software_paths;
   if (undefined == lpf)
      lpf = 500;
   if (undefined == cps)
      cps = 3;
   if (undefined == numRuns)
      numRuns = 1;
   if (undefined == beginRun)
      beginRun = 0;

   Out.Printf(Out.PriHigh, "\nglr_replog(%s, %d, %d) begin runs %d to %d\n",
         setupFunc.name,
         lpf,
         cps,
         beginRun,
         beginRun + numRuns - 1 );

   GLRandom.TestConfiguration.RestartSkipCount  = lpf;
   GLRandom.Golden.SkipCount                    = lpf;
   GLRandom.Golden.Codes                        = Golden.CheckSums;
   GLRandom.Golden.NumCodeBins                  = 97;
   GLRandom.AllowedSoftErrors                   = 0;
   GLRandom.FrameRetries                        = 0;
   GLRandom.Golden.StopOnError                  = true;
   GLRandom.Golden.AllowedBadBinsOneCheck       = 0;
   GLRandom.Golden.AllowedSumDiffOneCheck       = [ 0, 0, 0, 0, 0, 0 ];// argbsd
   GLRandom.SuperVerbose                        = false;
   GLRandom.Golden.Pause                        = Golden.Never;
   GLRandom.Golden.Print                        = Golden.Never;
   GLRandom.Golden.TgaAlphaToRgb                = false;

   // Loop for each run:

   var rc = 0;
   var badRuns = 0;
   var endRun = beginRun + numRuns;
   var run;

   for (run = beginRun; run < endRun; run++)
   {
      // Store:

      Out.Printf(Out.ScreenOnly, "\rRun %-4d  store..", run);

      GLRandom.Golden.Action                 = Golden.Store;
      GLRandom.Golden.DumpTga                = Golden.Never;
      GLRandom.TestConfiguration.StartLoop   = run * lpf;
      GLRandom.TestConfiguration.Loops       = lpf;

      GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
      GLRandom.FreeUserFragmentPrograms();
      setupFunc();
      rc = GLRandom.Run();

      if (0 != rc)
         break;

      // Check:

      GLRandom.Golden.Action  = Golden.Check;

      for (checkRun = 0; checkRun < cps; checkRun++)
      {
         Out.Printf(Out.ScreenOnly, "\rRun %-4d  check %d..", run, checkRun);

         GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
         GLRandom.FreeUserFragmentPrograms();
         setupFunc();
         rc = GLRandom.Run();

         if (0 != rc)
         {
            Out.Printf(Out.PriHigh, "\nRun %d.%d  bins %d/%d  diffs %d %d %d %d  %d %d (argb sd)\n",
                  run, checkRun,
                  GLRandom.Golden.TotalBinMiscompares,
                  GLRandom.Golden.NumCodeBins,
                  GLRandom.Golden.TotalCheckSumDiffs[0],
                  GLRandom.Golden.TotalCheckSumDiffs[1],
                  GLRandom.Golden.TotalCheckSumDiffs[2],
                  GLRandom.Golden.TotalCheckSumDiffs[3],
                  GLRandom.Golden.TotalCheckSumDiffs[4],
                  GLRandom.Golden.TotalCheckSumDiffs[5] );
            badRuns++;
            checkRun = cps;

            // Store a "pass" tga file.
            GLRandom.Golden.Action  = Golden.Store;
            GLRandom.Golden.DumpTga = Golden.OnStore;

            if (OperatingSystem == "Dos")
               GLRandom.Golden.TgaName = Out.Sprintf("%06dPc.TGA", run);
            else
               GLRandom.Golden.TgaName = Out.Sprintf("%012dPc.TGA", run);

            var passTgaName = GLRandom.Golden.TgaName;
            GLRandom.SetPicker(RND_TSTCTRL_LOGMODE, [RND_TSTCTRL_LOGMODE_Skip]);
            GLRandom.Run();

            // Store a "fail" tga file.
            GLRandom.Golden.Action  = Golden.Check;
            GLRandom.Golden.DumpTga = Golden.OnError;
            if (OperatingSystem == "Dos")
               GLRandom.Golden.TgaName = Out.Sprintf("%06dFc.TGA", run);
            else
               GLRandom.Golden.TgaName = Out.Sprintf("%012dFc.TGA", run);

            var retry;
            for (retry = 1; retry <= 20; retry++)
            {
               rc = GLRandom.Run();
               if (0 != rc)
               {
                  // We have another failure, and now we have a pair of .TGA files also.
                  Out.Printf(Out.PriHigh, "\nRun %d.%d  bins %d/%d  diffs %d %d %d %d  %d %d (argb sd)\n",
                        run, checkRun + retry,
                        GLRandom.Golden.TotalBinMiscompares,
                        GLRandom.Golden.NumCodeBins,
                        GLRandom.Golden.TotalCheckSumDiffs[0],
                        GLRandom.Golden.TotalCheckSumDiffs[1],
                        GLRandom.Golden.TotalCheckSumDiffs[2],
                        GLRandom.Golden.TotalCheckSumDiffs[3],
                        GLRandom.Golden.TotalCheckSumDiffs[4],
                        GLRandom.Golden.TotalCheckSumDiffs[5] );

                  // "fail" image is in memory.  Load "pass" image, print miscomparing pixels.
                  var rv = new Array;
                  Display.GetPitch(Display.Selected, rv);
                  var pitch = rv[0];

                  var width = GLRandom.TestConfiguration.DisplayWidth;
                  if (undefined == width)
                     width = TestConfiguration.DisplayWidth;

                  var height = GLRandom.TestConfiguration.DisplayHeight;
                  if (undefined == height)
                     height = TestConfiguration.DisplayHeight;

                  var depth = GLRandom.TestConfiguration.DisplayDepth;
                  if (undefined == depth)
                     depth = TestConfiguration.DisplayDepth;

                  Display.GetImageOffset(Display.Selected, rv);
                  var offsetFail = rv[0];
                  var offsetPass = offsetFail + height * pitch;
                  Out.Printf(Out.PriHigh, "%x %x\n", offsetPass, offsetFail);

                  rc = Memory.ReadTga(
                        passTgaName,
                        Bus.FbBaseAddress + offsetPass,
                        width,
                        height,
                        depth,
                        pitch);
                  if (0 == rc)
                  {
                     var pixels = Memory.CompareImages(
                           offsetPass,
                           offsetFail,
                           width,
                           height,
                           depth,
                           pitch,
                           10 /*max errs to print*/ );
                     if (pixels != GLRandom.Golden.TotalBinMiscompares)
                     {
                        Out.Printf(Out.PriHigh, "\nRun %d.%d  bins %d/%d  actual miscomparing pixels = %d\n",
                           run, checkRun + retry,
                           GLRandom.Golden.TotalBinMiscompares,
                           GLRandom.Golden.NumCodeBins,
                           pixels );
                     }
                  }
                  break;
               }
            }
         }
      } // checkRun
   } // run

   Out.Printf(Out.PriHigh, "\nglr_replog(%s, %d, %d) %d errors in runs %d to %d.\n\n",
         setupFunc.name,
         lpf,
         cps,
         badRuns,
         beginRun,
         beginRun + numRuns - 1 );
   return rc;
}

//------------------------------------------------------------------------------
function glr()
{
   GLRandom.Run();
}
function glrs()
{
   GLRandom.Golden.Action = Golden.Store;
   GLRandom.SetPicker(RND_TSTCTRL_LOGMODE, [RND_TSTCTRL_LOGMODE_Skip]);
   glr();
}
function glrc()
{
   GLRandom.Golden.Action = Golden.Check;
   GLRandom.SetPicker(RND_TSTCTRL_LOGMODE, [RND_TSTCTRL_LOGMODE_Skip]);
   glr();
}

// On Charlie's target system, copy and import the latest glrandom.js.
function x()
{
   System("copy e:\\src\\sw\\nvr40\\diag\\mods\\js\\glrandom.js .");
   Import("glrandom.js");
}

//------------------------------------------------------------------------------
function glr_demo(setupFunc, loopsPerFrame, noPause, numFrames, verbose)
{
   // Set defaults for unused arguments:

   if (undefined == setupFunc)
      setupFunc = glr_avoid_software_paths;

   if (undefined == loopsPerFrame)
      loopsPerFrame = 500;

   if (undefined == noPause)
      noPause = false;

   if (undefined == numFrames)
   {
      if (noPause)
         numFrames = 10;
      else
         numFrames = 100;
   }

   if (undefined == verbose)
      verbose = false;


   // Set options based on arguments:

   GLRandom.Golden.Action                    = Golden.Skip;
   GLRandom.Golden.SkipCount                 = loopsPerFrame;
   GLRandom.TestConfiguration.RestartSkipCount = loopsPerFrame;

   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   setupFunc();

   if (noPause)
      GLRandom.Golden.Pause = Golden.Never;
   else
      GLRandom.Golden.Pause = Golden.OnSkip;

   GLRandom.TestConfiguration.Loops = numFrames * loopsPerFrame;

   if (verbose)
   {
      LevVerbose();
      GLRandom.SuperVerbose = true;
   }
   else
   {
      // LevNormal();
      GLRandom.SuperVerbose = false;
   }
   GLRandom.TestConfiguration.UseTiledSurface   = false;


   // Run the test:

   return GLRandom.Run();
}

//------------------------------------------------------------------------------
// Make as plain and boring a test as possible.
//
function glr_boring()
{
   GLRandom.SetPicker(RND_CMB_THEME, [ RND_CMB_THEME_Disabled ]);

   GLRandom.SetPicker(RND_FOG_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FOG_DIST_MODE, [ GL_EYE_RADIAL_NV ]);
   GLRandom.SetPicker(RND_FOG_MODE, [ GL_LINEAR ]);
   GLRandom.SetPicker(RND_FOG_COORD, [ GL_FOG_COORDINATE_EXT ]);

   GLRandom.SetPicker(RND_FRAG_DEPTH_TEST, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_ALPHA_FUNC, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_BLEND_EQN, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_DEPTH_FUNC, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_LOGIC_OP, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_STENCIL_FUNC, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_SCISSOR_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_VEIWPORT_OFFSET_X,  [ 0 ]);
   GLRandom.SetPicker(RND_FRAG_VEIWPORT_OFFSET_Y,  [ 0 ]);
   GLRandom.SetPicker(RND_FRAG_DEPTH_CLAMP,  [ GL_FALSE ]);

   GLRandom.SetPicker(RND_GEOM_BBOX_WIDTH,              [ RND_GEOM_WorldWidth/25 - 5]);
   GLRandom.SetPicker(RND_GEOM_BBOX_HEIGHT,             [ RND_GEOM_WorldHeight/20 - 5]);
   GLRandom.SetPicker(RND_GEOM_BBOX_DEPTH,              [ 1 ]);
   GLRandom.SetPicker(RND_GEOM_BBOX_XOFFSET,            [ RND_GEOM_WorldWidth/25 + 1]);
   GLRandom.SetPicker(RND_GEOM_BBOX_YOFFSET,            [ RND_GEOM_WorldHeight/20 + 1]);
   GLRandom.SetPicker(RND_GEOM_FORCE_BIG_SIMPLE,        [ GL_TRUE ]);
   GLRandom.SetPicker(RND_GEOM_FRONT_FACE, [ GL_CCW ]);
   GLRandom.SetPicker(RND_GEOM_VTX_NORMAL_SCALING, [ RND_GEOM_VTX_NORMAL_SCALING_Unscaled ]);
   GLRandom.SetPicker(RND_GEOM_CULL_FACE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_GEOM_BBOX_FACES_FRONT, [ GL_TRUE ]);
   GLRandom.SetPicker(RND_GEOM_VERTEX_WEIGHTING_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_GEOM_USE_PERSPECTIVE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_GEOM_VXPGM_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_GEOM_VXPGM_POINTSZ, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_GEOM_VXPGM_TWOSIDE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_GEOM_TXU_GEN_ENABLED, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_GEOM_TXU_GEN_MODE, [ GL_OBJECT_LINEAR ]);
   GLRandom.SetPicker(RND_GEOM_TXMX_OPERATION, [ RND_GEOM_TXMX_OPERATION_Identity ]);
   GLRandom.SetPicker(RND_GEOM_USER_CLIP_PLANE_MASK, [ 0 ]);
   GLRandom.SetPicker(RND_GEOM_MODELVIEW_OPERATION, [ RND_GEOM_MODELVIEW_OPERATION_Identity]);

   GLRandom.SetPicker(RND_LIGHT_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_LIGHT_SHADE_MODEL, [ GL_SMOOTH ]);
   GLRandom.SetPicker(RND_LIGHT_TYPE, [ RND_LIGHT_TYPE_Directional ]);
   GLRandom.SetPicker(RND_LIGHT_SPOT_CUTOFF, [ 180 ]);
   GLRandom.SetPicker(RND_LIGHT_BACK, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_LIGHT_MODEL_LOCAL_VIEWER, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_LIGHT_MODEL_TWO_SIDE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_LIGHT_MODEL_COLOR_CONTROL, [ GL_SINGLE_COLOR ]);
   GLRandom.SetPicker(RND_LIGHT_MAT_IS_EMISSIVE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_LIGHT_MAT, [ GL_AMBIENT_AND_DIFFUSE ]);

   GLRandom.SetPicker(RND_PRIM_POINT_SMOOTH_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_PRIM_POINT_SIZE, [ 1.0 ]);
   GLRandom.SetPicker(RND_PRIM_LINE_SMOOTH_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_PRIM_LINE_WIDTH, [ 1.0 ]);
   GLRandom.SetPicker(RND_PRIM_LINE_STIPPLE_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_PRIM_POLY_MODE, [ GL_FILL ]);
   GLRandom.SetPicker(RND_PRIM_POLY_STIPPLE_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_PRIM_POLY_SMOOTH_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_PRIM_POLY_OFFSET_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_PRIM_POINT_ATTEN_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_PRIM_PN_TRI_TESS_LEVEL, [ 0 ]);

   GLRandom.SetPicker(RND_TX_DIM, [ GL_TEXTURE_2D ]);
   GLRandom.SetPicker(RND_TX_WIDTH, [ 64 ]);
   GLRandom.SetPicker(RND_TX_HEIGHT, [ 64 ]);
   GLRandom.SetPicker(RND_TX_BASE_MM, [ 0 ]);
   GLRandom.SetPicker(RND_TX_MAX_MM, [ 100 ]);
   GLRandom.SetPicker(RND_TX_NAME, [ RND_TX_NAME_Checkers ]);
   GLRandom.SetPicker(RND_TXU_ENABLE_MASK, [ 0 ]);
   GLRandom.SetPicker(RND_TXU_WRAPMODE, [ GL_REPEAT ]);
   GLRandom.SetPicker(RND_TXU_MIN_FILTER, [ GL_NEAREST ]);
   GLRandom.SetPicker(RND_TXU_MAG_FILTER, [ GL_NEAREST ]);
   GLRandom.SetPicker(RND_TXU_MIN_LAMBDA, [ 0.0 ]);
   GLRandom.SetPicker(RND_TXU_MAX_LAMBDA, [ 0.0 ]);
   GLRandom.SetPicker(RND_TXU_BIAS_LAMBDA, [ 0.0 ]);
   GLRandom.SetPicker(RND_TXU_MAX_ANISOTROPY, [ 1.0 ]);
   GLRandom.SetPicker(RND_TX_INTERNAL_FORMAT, [ GL_RGBA8 ]);
   GLRandom.SetPicker(RND_TX_DEPTH, [ 64 ]);
   GLRandom.SetPicker(RND_TX_HAS_BORDER, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_TX_SHADER_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_TXSH_PROG, [ RND_TXSH_PROG_TxNd ]);
   GLRandom.SetPicker(RND_TX_FRAG_PROG_ENABLE, [ GL_FALSE ]);

   GLRandom.SetPicker(RND_VX_PRIMITIVE, [ GL_TRIANGLES ]);
   GLRandom.SetPicker(RND_VX_SEND_METHOD, [ RND_VX_SEND_METHOD_Immediate ]);
   GLRandom.SetPicker(RND_VX_PER_LOOP, [ 8 ]);
   GLRandom.SetPicker(RND_VX_EDGE_FLAG, [ GL_TRUE ]);
   GLRandom.SetPicker(RND_VX_MEMORY_TYPE, [ Memory.Pci ]);
   GLRandom.SetPicker(RND_VX_ARRAY_RANGE_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VX_COMPILED_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VX_NEW_GROUP, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VX_DO_SHUFFLE_STRUCT, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VX_COLOR_WHITE, [ GL_TRUE ]);
   GLRandom.SetPicker(RND_VX_W, [ 1.0 ]);

   GLRandom.SetPicker(RND_VXFMT_COORD_SIZE, [ 3 ]);
   GLRandom.SetPicker(RND_VXFMT_COORD_DATA_TYPE, [ GL_FLOAT ]);
   GLRandom.SetPicker(RND_VXFMT_HAS_NORMAL, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VXFMT_NORMAL_DATA_TYPE, [ GL_FLOAT ]);
   GLRandom.SetPicker(RND_VXFMT_HAS_PRICOLOR, [ GL_TRUE ]);
   GLRandom.SetPicker(RND_VXFMT_HAS_EDGE_FLAG, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VXFMT_HAS_SECCOLOR, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VXFMT_HAS_FOG_COORD, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VXFMT_HAS_WEIGHT, [ GL_FALSE ]);
}

//------------------------------------------------------------------------------
// Set up the pickers and testconfig to draw a single loop or range of loops.
//
function glr_isolate(firstLoop, lastLoop)
{
   if ((undefined == firstLoop) ||
       (0 > firstLoop))
   {
      Out.Printf(Out.PriHigh, "useage: glr_isolate(firstLoop, lastLoop)\n");
      return 0;
   }

   if ((undefined == lastLoop) ||
       (lastLoop < firstLoop))
   {
      lastLoop = firstLoop;
   }

   var skipLoops  = firstLoop % GLRandom.TestConfiguration.RestartSkipCount;
   var drawLoops  = lastLoop - firstLoop + 1;

   GLRandom.TestConfiguration.Loops     = skipLoops + drawLoops;
   GLRandom.TestConfiguration.StartLoop = firstLoop - skipLoops;

   GLRandom.SetPicker(RND_TSTCTRL_SKIP, ["list", [skipLoops, GL_TRUE], [drawLoops, GL_FALSE]]);
}

//------------------------------------------------------------------------------
// Print the current picker values for all pickers to the logfile.
//
function glr_printpicks()
{
   var sizes = [
       RND_CMB_NUM_PICKERS
      ,RND_EVAL_NUM_PICKERS
      ,RND_FOG_NUM_PICKERS
      ,RND_FRAG_NUM_PICKERS
      ,RND_GEOM_NUM_PICKERS
      ,RND_LIGHT_NUM_PICKERS
      ,RND_PRIM_NUM_PICKERS
      ,RND_TX_NUM_PICKERS
      ,RND_VX_NUM_PICKERS
      ,RND_VXFMT_NUM_PICKERS
      ,RND_TSTCTRL_NUM_PICKERS
   ]
   var names = [
       "RND_CMB"
      ,"RND_EVAL"
      ,"RND_FOG"
      ,"RND_FRAG"
      ,"RND_GEOM"
      ,"RND_LIGHT"
      ,"RND_PRIM"
      ,"RND_TX"
      ,"RND_VX"
      ,"RND_VXFMT"
      ,"RND_TSTCTRL"
   ]

   for(i = 0; i < RND_NUM_RANDOMIZERS; i++)
   {
      Out.Printf(Out.PriHigh,
         "// Randomizer module: %s (%d FancyPickers):\n",
         names[i], sizes[i]);

      for(j = 0; j < sizes[i]; j++)
      {
         Out.Printf(Out.FileOnly,
                  "\t[%d] = %s;\n",
                  i*RND_BASE_OFFSET+j,
                  GLRandom.GetPick(i*RND_BASE_OFFSET+j));
      }
   }
}

//------------------------------------------------------------------------------
// When we dump a .TGA file, the name looks like this:
//
//    xxxxnnnc.TGA  (for color buffer)
//    xxxxnnnz.TGA  (for depth buffer)
//
// The nnn is an encoded loop number in base 36.
// If the loop is > 46,655, the 3 least significant "digits" are used.
// If the loop is < 1296, it is 0-padded to 3 "digits".
//
function LoopToTgaName(loop)
{
   var xlatStr = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
   //                       01234567890123456789012345
   //             000000000011111111112222222222333333

   var str = "";

   while( loop )
   {
      str = xlatStr[ loop % 36 ] + str;

      loop = Math.floor(loop / 36);
   }
   Print(str);
}


//------------------------------------------------------------------------------
function glr_demoX()
{
   glr_avoid_software_paths();
   glr_eyeball_check(6,5);
   GLRandom.ClearLines = false;
   GLRandom.SetPicker(RND_VX_PRIMITIVE, [RND_VX_PRIMITIVE_Solid]);
   //GLRandom.SetPicker(RND_VX_PER_LOOP, [ 300 ]);
   GLRandom.SetPicker(RND_CMB_THEME,         [ RND_CMB_THEME_4WayBlend ]);
   GLRandom.SetPicker(RND_GEOM_VXPGM_INDEX, [RND_GEOM_VXPGM_INDEX_IdxLight012]);
   GLRandom.SetPicker(RND_GEOM_VXPGM_ENABLE, [GL_TRUE]);
}
function demo(arg)
{
   if (Gpu.DeviceId != Gpu.NV2A)
   {
      GLRandom.TestConfiguration.DisplayWidth = 1280;
      GLRandom.TestConfiguration.DisplayHeight = 1024;
   }
   glr_demo(glr_demoX, 6*5);
}

//------------------------------------------------------------------------------
function glr_prims(prim)
{
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_avoid_software_paths();
   GLRandom.SetPicker(RND_VX_PRIMITIVE, [ prim ]);
   GLRandom.Golden.Action                = Golden.Skip;
   GLRandom.Golden.SkipCount             =      100*1000;
   GLRandom.TestConfiguration.RestartSkipCount =      100*1000;
   GLRandom.TestConfiguration.Loops            = 1000*100*1000;
   GLRandom.Run();
}
//------------------------------------------------------------------------------
// XXX
//
function glr_shiny_strips()
{
   // Set everything to boring defaults.
   glr_boring();

   GLRandom.SetPicker(RND_VX_PRIMITIVE,            [ GL_TRIANGLE_STRIP ]);
   GLRandom.SetPicker(RND_VX_PER_LOOP,             [ 40 ]);
   GLRandom.SetPicker(RND_VXFMT_HAS_NORMAL,        [ GL_TRUE ]);
   GLRandom.SetPicker(RND_GEOM_BBOX_WIDTH,         [[1, RND_GEOM_WorldWidth/5 - 2]]);
   GLRandom.SetPicker(RND_GEOM_BBOX_HEIGHT,        [[1, RND_GEOM_WorldHeight/4 - 2]]);
   GLRandom.SetPicker(RND_GEOM_BBOX_DEPTH,         [ RND_GEOM_WorldDepth/2 ]);
   GLRandom.SetPicker(RND_GEOM_BBOX_XOFFSET,       [[1, RND_GEOM_WorldWidth/5 + 2]]);
   GLRandom.SetPicker(RND_GEOM_BBOX_YOFFSET,       [[1, RND_GEOM_WorldHeight/4 + 2]]);

   // Restore default random tables for texturing.
   GLRandom.SetDefaultPicker(RND_TXU_ENABLE_MASK);
   GLRandom.SetDefaultPicker(RND_TX_NAME);
   GLRandom.SetDefaultPicker(RND_TXSH_CULL_MODES);
   GLRandom.SetDefaultPicker(RND_TXSH_DOT_UNSIGNED_MAPPING);
   GLRandom.SetDefaultPicker(RND_TXSH_PROG);
   GLRandom.SetDefaultPicker(RND_TXU_WRAPMODE);
   GLRandom.SetDefaultPicker(RND_TXU_MAG_FILTER);
   GLRandom.SetDefaultPicker(RND_TXU_MIN_FILTER);
   GLRandom.SetDefaultPicker(RND_TXU_MAX_LAMBDA);
   GLRandom.SetDefaultPicker(RND_TXU_MIN_LAMBDA);
   GLRandom.SetDefaultPicker(RND_TXU_BIAS_LAMBDA);
   GLRandom.SetDefaultPicker(RND_TXU_MAX_ANISOTROPY);
   GLRandom.SetDefaultPicker(RND_TX_DIM);
   GLRandom.SetDefaultPicker(RND_TX_INTERNAL_FORMAT);

   // Set rendering modes that look nice.
   GLRandom.SetPicker(RND_CMB_THEME,               [ RND_CMB_THEME_4WayBlend ]);
   GLRandom.SetPicker(RND_GEOM_VXPGM_ENABLE,            [ GL_TRUE ]);
   GLRandom.SetPicker(RND_GEOM_VXPGM_INDEX,             [ RND_GEOM_VXPGM_INDEX_IdxLight012 ]);
}

//------------------------------------------------------------------------------
// Set options to "eyeball" check glrandom features.
//
function glr_eyeball_check(nAcross, nDown)
{
   // Force a visible draw.
   GLRandom.SetPicker(RND_GEOM_BBOX_FACES_FRONT,        [ GL_TRUE ]);
   GLRandom.SetPicker(RND_GEOM_CULL_FACE,               [ GL_BACK ]);
   GLRandom.SetPicker(RND_FRAG_BLEND_EQN,               [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_DEPTH_FUNC,              [ GL_LESS ]);
   GLRandom.SetPicker(RND_FRAG_STENCIL_FUNC,            [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_STENCIL_OP,              [ GL_FALSE ]);
   GLRandom.SetPicker(RND_FRAG_ALPHA_FUNC,              [ GL_FALSE ]);

   // Draw nice big square tris
   GLRandom.SetPicker(RND_GEOM_FORCE_BIG_SIMPLE,        [ GL_TRUE ]);
   GLRandom.SetPicker(RND_VX_PRIMITIVE,                 [ GL_QUADS ]);
   GLRandom.SetPicker(RND_PRIM_POLY_MODE,               [ GL_FILL ]);
   GLRandom.SetPicker(RND_GEOM_BBOX_WIDTH,              [ RND_GEOM_WorldWidth/nAcross - 20]);
   GLRandom.SetPicker(RND_GEOM_BBOX_HEIGHT,             [ RND_GEOM_WorldHeight/nDown - 20]);
   GLRandom.SetPicker(RND_GEOM_BBOX_XOFFSET,            [ RND_GEOM_WorldWidth/nAcross + 1]);
   GLRandom.SetPicker(RND_GEOM_BBOX_YOFFSET,            [ RND_GEOM_WorldHeight/nDown + 1]);

   // Avoid geometry distortions
   GLRandom.SetPicker(RND_GEOM_VERTEX_WEIGHTING_ENABLE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VX_W,                         [ 1.0 ]);
   GLRandom.SetPicker(RND_FRAG_VEIWPORT_OFFSET_X,       [ 0 ]);
   GLRandom.SetPicker(RND_FRAG_VEIWPORT_OFFSET_Y,       [ 0 ]);
}


//------------------------------------------------------------------------------
// Experiments...
//

//-----------------------------------------------------------------------------
// Isolate!
//
// A set of functions for isolating a particular draw that fails on a bad chip.
// Once it is isolated, we can capture the GL source code that exposed the
// hardware flaw, and migrate that micro test upstream from this board-level
// test to the chip tester stations.
//
var accumfile = "accum.bin";
var isofile   = "iso.bin";

if (OperatingSystem == "Xos")
{
   accumfile = "U:\\accum.bin";
   isofile = "U:\\iso.bin";
}

//
// Step (1): on a good board
//
// Build a golden file with checksums taken on every draw,
// for each of the 500 draws in the frame containing badloop.
//
function iso_store_frame(badloop)
{
   Golden.ReadFile(accumfile);

   // store on every loop
   GLRandom.Golden.Action = Golden.Store;
   GLRandom.Golden.SkipCount = 0;

   var lpf = GLRandom.TestConfiguration.RestartSkipCount;
   var rem = badloop % lpf;

   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_avoid_software_paths();
   glr_isolate(badloop - rem, badloop - rem + lpf - 1);

   // Run the test, generate golden values.
   var rc = GLRandom.Run();

   // Write the golden values to disk.
   Golden.WriteFile(accumfile);
   return rc;
}
//
// Step (2): on the bad board
//
// Using the golden file build by store (above), find the earliest
// failing draw of the 500 in the frame containing badloop.
//
function iso_check_frame(badloop)
{
   Golden.ReadFile(accumfile);

   GLRandom.Golden.Action = Golden.Check;
   GLRandom.Golden.SkipCount = 0;

   var lpf = GLRandom.TestConfiguration.RestartSkipCount;
   var rem = badloop % lpf;

   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_avoid_software_paths();
   glr_isolate(badloop - rem, badloop - rem + lpf - 1);

   var rc = GLRandom.Run();
}
//
// Step (3): on a good board
//
// Draw just the exact failing loop (discovered with check(), above) and
// get a golden file with that .crc file in it.
//
function iso_store_one(badloop)
{
   Golden.ReadFile(isofile);

   // store on every loop
   GLRandom.Golden.Action = Golden.Store;
   GLRandom.Golden.SkipCount = 0;
   GLRandom.Golden.Action = Golden.Store;
   GLRandom.Golden.DumpTga = Golden.Always;
   GLRandom.Golden.TgaName = "i" + badloop;
   if (OperatingSystem == "Xos")
   {
      GLRandom.Golden.TgaName = "u:\\i" + badloop;
   }
   else
   {
      GLRandom.Golden.Pause = Golden.Always;
   }

   GLRandom.SuperVerbose  = true;
   LevVerbose();

   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_avoid_software_paths();
   glr_isolate(badloop);

   var rc = GLRandom.Run();

   // Write the golden values to disk.
   Golden.WriteFile(isofile);

   return rc;
}
//
// Step (4): on the bad board
//
// Draw just the exact failing loop and confirm that it fails when drawn
// all by itself, without the previous draws already in the frame buffer.
// If it doesn't, you have a failure that depends on multiple draw loops,
// and it will be a bit of a pain to shrink down into the chip tester...
// Uses the golden file produced by isostore, above.
//
// Note: produces a .TGA image file that you can compare with the result
// of the next step below, to see exactly what was rendered wrong.
//
function iso_check_one(badloop)
{
   Golden.ReadFile(isofile);

   GLRandom.Golden.Action = Golden.Check;
   GLRandom.Golden.SkipCount = 0;
   GLRandom.Golden.DumpTga = Golden.OnError;
   GLRandom.Golden.TgaName = "if" + badloop;
   if (OperatingSystem == "Xos")
   {
      GLRandom.Golden.TgaName = "u:\\if" + badloop;
   }

   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_avoid_software_paths();
   glr_isolate(badloop);

   var rc = GLRandom.Run();
}
//
// Step (5): on the good board
//
// Draw just the exact failing loop by itself, dumping a .TGA image file for
// the resulting color and depth buffers, and a .C file containing source code
// for linking into the ogtest package.
//
function iso_dump_one(badloop)
{
   Golden.ReadFile(isofile);

   GLRandom.Golden.Action = Golden.Skip;
   GLRandom.Golden.SkipCount = 0;
   GLRandom.Golden.DumpTga = Golden.OnSkip;
   if (OperatingSystem == "Xos")
   {
      GLRandom.Golden.TgaName = "u:\\if" + badloop;
   }

   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_avoid_software_paths();
   glr_isolate(badloop);
   GLRandom.FakeGLTexImages = true;
   GLRandom.SetPicker(RND_TSTCTRL_EMIT_FAKE_GL, [1]);
   var rc = GLRandom.Run();
}




function gen_test_escape(badloop, nLoops)
{
   //var badloop = GLRandom.Golden.ForceErrorLoop;

   //disable out-of-band vertex arrays (VARs loaded into frame buffer where hardware can pull it)
   //because it's not supported by ACF
   GLRandom.SetPicker(RND_VX_ARRAY_RANGE_ENABLE, ["random", [1, GL_FALSE]]);

   TestConfiguration.Loops = nLoops;
   if (badloop > nLoops) {
      Out.Printf(Out.PriHigh, "Error loop greater than TestConfiguration.Loops.\n");
      return;
   }

  // glr_hwtest();
   iso_store_frame(badloop);

   GLRandom.Golden.ForceErrorLoop = badloop;
   iso_check_frame(badloop);
   GLRandom.Golden.ForceErrorLoop = -1; //i'm hoping this means it just won't be an error loop period
   iso_store_one(badloop);


   iso_check_one(badloop);

   GLRandom.Golden.ForceErrorLoop = badloop;
   DosOpenGL.Registry.CaptureEnable = 1; //enable acf capture for error dump
   iso_dump_one(badloop);
   DosOpenGL.Registry.CaptureEnable = 0; //restore state
   GLRandom.Golden.ForceErrorLoop = -1;

   Out.Printf(Out.PriLow, "Completed test escape generation.\n");
   return;
}

function glr_fakegl()
{
   var nAcross = 2;
   var nDown   = 2;
   var lpf     = nAcross * nDown * 4;

   GLRandom.Golden.Action                       = Golden.Skip;
   GLRandom.Golden.SkipCount                    = lpf;
   GLRandom.TestConfiguration.RestartSkipCount  = lpf;
   GLRandom.TestConfiguration.Loops             = lpf * 25;
   GLRandom.TestConfiguration.DisplayWidth      = 640;
   GLRandom.TestConfiguration.DisplayHeight     = 480;
   GLRandom.TestConfiguration.UseTiledSurface   = false;

   // C++ default tables
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();

   // don't allow sw fallback stuff
   glr_avoid_software_paths();
   //glr_progressive();

   // Force a standard vertex format.
   // GLRandom.SetPicker(RND_VXFMT_COORD_SIZE,        [4]);
   // GLRandom.SetPicker(RND_VXFMT_COORD_DATA_TYPE,   [GL_FLOAT]);
   // GLRandom.SetPicker(RND_VXFMT_HAS_NORMAL,        [GL_TRUE]);
   // GLRandom.SetPicker(RND_VXFMT_NORMAL_DATA_TYPE,  [GL_FLOAT]);
   // GLRandom.SetPicker(RND_VXFMT_HAS_PRICOLOR,      [GL_TRUE]);
   // GLRandom.SetPicker(RND_VXFMT_HAS_EDGE_FLAG,     [GL_FALSE]);
   // GLRandom.SetPicker(RND_VXFMT_TXU_COORD_SIZE,    [4]);
   // GLRandom.SetPicker(RND_VXFMT_HAS_SECCOLOR,      [GL_TRUE]);
   // GLRandom.SetPicker(RND_VXFMT_HAS_FOG_COORD,     [GL_TRUE]);
   // GLRandom.SetPicker(RND_VXFMT_HAS_WEIGHT,        [GL_TRUE]);
   // GLRandom.SetPicker(RND_VX_NEW_GROUP,            [ GL_FALSE ]);
   // GLRandom.SetPicker(RND_VX_DO_SHUFFLE_STRUCT,    [ GL_FALSE ]);

   // all random tx images
   GLRandom.SetPicker(RND_TX_NAME, [RND_TX_NAME_Random]);

   // Fill the screen nicely with simple quads.
   GLRandom.SetPicker(RND_GEOM_BBOX_WIDTH,    [[1, RND_GEOM_WorldWidth/nAcross - 100]]);
   GLRandom.SetPicker(RND_GEOM_BBOX_HEIGHT,   [[1, RND_GEOM_WorldHeight/nDown - 100]]);
   GLRandom.SetPicker(RND_GEOM_BBOX_DEPTH,    [ RND_GEOM_WorldDepth/2      ]);
   //GLRandom.SetPicker(RND_GEOM_BBOX_Z_BASE,   [ RND_GEOM_WorldDepth/2      ]);
   GLRandom.SetPicker(RND_GEOM_BBOX_XOFFSET,  [[1, (RND_GEOM_WorldWidth-1)/nAcross]]);
   GLRandom.SetPicker(RND_GEOM_BBOX_YOFFSET,  [[1, (RND_GEOM_WorldHeight-1)/nDown]]);
   //GLRandom.SetPicker(RND_GEOM_FORCE_BIG_SIMPLE,        [ GL_TRUE ]);
   //GLRandom.SetPicker(RND_VX_PRIMITIVE,                 [ GL_QUADS ]);
   //GLRandom.SetPicker(RND_PRIM_POLY_MODE,               [ GL_FILL ]);
   //GLRandom.SetPicker(RND_VX_W,                         [ 1.0 ]);
   //GLRandom.SetPicker(RND_GEOM_USE_PERSPECTIVE,         [ GL_FALSE ]);
   //GLRandom.SetPicker(RND_VX_PER_LOOP,                  [ 4 ]);
   //GLRandom.SetPicker(RND_GEOM_VERTEX_WEIGHTING_ENABLE, [ GL_FALSE ]);

   // More interesting, visible draws.
   //GLRandom.SetPicker(RND_CMB_NUM_STAGES,
   //   [ "random",
   //      [ 1, 1, 4],
   //   ] );
   //GLRandom.SetPicker(RND_LIGHT_MODEL_TWO_SIDE, [GL_TRUE]);
   //GLRandom.SetPicker(RND_LIGHT_NUM_ON, [2]);
   //
   //GLRandom.SetPicker(RND_GEOM_CULL_FACE,
   //   [ "random",
   //      [ 1, GL_FALSE],
   //   ] );
   //GLRandom.SetPicker(RND_GEOM_FRONT_FACE, [GL_CCW]);

   // Avoid unsupported tx formats.
   GLRandom.SetPicker(RND_TX_INTERNAL_FORMAT,
      [ "random",
         [ 1, 1],
         [ 1, 2],
         [ 1, GL_RGB],
         [ 5, GL_RGBA],
         [ 1, GL_ALPHA],
         [ 1, GL_LUMINANCE],
         [ 1, GL_LUMINANCE_ALPHA],
         [ 1, GL_INTENSITY],
         //[ 1, GL_COMPRESSED_RGB_S3TC_DXT1_EXT],
         //[ 1, GL_COMPRESSED_RGBA_S3TC_DXT1_EXT],
         //[ 1, GL_COMPRESSED_RGBA_S3TC_DXT3_EXT],
         //[ 1, GL_COMPRESSED_RGBA_S3TC_DXT5_EXT],
         [ 2, GL_COLOR_INDEX8_EXT],
         //[ 1, GL_SIGNED_RGBA_NV],
         //[ 1, GL_SIGNED_RGB_NV],
         //[ 1, GL_SIGNED_LUMINANCE_NV],
         //[ 1, GL_SIGNED_LUMINANCE_ALPHA_NV],
         //[ 1, GL_SIGNED_ALPHA_NV],
         //[ 1, GL_SIGNED_INTENSITY_NV],
         //[ 1, GL_SIGNED_RGB_UNSIGNED_ALPHA_NV],
         //[ 1, GL_HILO_NV],
         //[ 1, GL_SIGNED_HILO_NV],
         //[ 1, GL_DSDT_NV],
         //[ 1, GL_DSDT_MAG_NV],
         //[ 1, GL_DSDT_MAG_INTENSITY_NV],
      ] );

   // emit the fakegl.
   GLRandom.SetPicker(RND_TSTCTRL_EMIT_FAKE_GL, [GL_TRUE]);
   GLRandom.FakeGLTexImages      = false;
   GLRandom.FakeGLMinimalState   = false;
   GLRandom.Golden.DumpTga       = Golden.OnSkip;
   GLRandom.Golden.Print         = Golden.Never;

   LevVerbose();

   GLRandom.Run();
}
function glr_copy_emit()
{
   System("copy glr*.c d:\\src\\hw\\nv20\\ogtest\\tests\\common\\glrandom");
}
function glr_run_trace(name)
{
   Run3DTrace.TestConfiguration = {};
   Run3DTrace.Golden = {};
   Run3DTrace.TraceFile = "d:/src/hw/nv20/ogtest/debug/x/" + name + "/test.hdr";
   Run3DTrace.TestConfiguration.DisplayWidth = 640;
   Run3DTrace.TestConfiguration.DisplayHeight= 480;
   Run3DTrace.TestConfiguration.UseTiledSurface = false;
   Run3DTrace.Golden.Action = Golden.Skip;
   Run3DTrace.Golden.Pause  = Golden.OnSkip;
   Run3DTrace.TestConfiguration.Loops = 1;
   Run3DTrace.Run();
}

function glr_runw(seed)
{
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_whatever();

   GLRandom.TestConfiguration.Seed = seed;

   Log.Never("GLRandom.Run");

   var rc = GLRandom.Run();
   if (rc)
      glr_print_miscompare_details();

   Log.OnError("GLRandom.Run");
   return rc;
}

function glr_dumpw(seed)
{
   GLRandom.Golden.Action                       = Golden.Skip;
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_whatever();

   GLRandom.TestConfiguration.Loops             *= 5;

   GLRandom.TestConfiguration.Seed = seed;

   GLRandom.TestConfiguration.DisplayWidth      = 640;
   GLRandom.TestConfiguration.DisplayHeight     = 480;
   GLRandom.TestConfiguration.UseTiledSurface   = false;

   GLRandom.SetPicker(RND_TSTCTRL_EMIT_FAKE_GL, [GL_TRUE]);
   GLRandom.FakeGLTexImages = false; //true;
   GLRandom.FakeGLMinimalState = true;

   GLRandom.Golden.DumpTga = Golden.OnSkip;

   GLRandom.Run();
}

function glr_whatever()
{
   var nAcross  = 10;
   var nDown    = 8;
   var overDraw = 150 / (nAcross*nDown);
   var overDraw = 1500 / (nAcross*nDown);
   var lpf      = nAcross * nDown * overDraw;

   //GLRandom.TestConfiguration.DisplayWidth = 160;
   //GLRandom.TestConfiguration.DisplayHeight = 120;

   glr_avoid_software_paths();

   GLRandom.TestConfiguration.RestartSkipCount  = lpf;
   GLRandom.Golden.SkipCount                    = lpf;
   GLRandom.TestConfiguration.Loops             = lpf * 1;
   GLRandom.SetPicker(RND_GEOM_BBOX_WIDTH,    [[1, RND_GEOM_WorldWidth/nAcross - 2]]);
   GLRandom.SetPicker(RND_GEOM_BBOX_HEIGHT,   [[1, RND_GEOM_WorldHeight/nDown - 2]]);
   GLRandom.SetPicker(RND_GEOM_BBOX_XOFFSET,  [[1, RND_GEOM_WorldWidth/nAcross + 2]]);
   GLRandom.SetPicker(RND_GEOM_BBOX_YOFFSET,  [[1, RND_GEOM_WorldHeight/nDown + 2]]);

   // Fix the vertex format.
   GLRandom.SetPicker(RND_VX_ARRAY_RANGE_ENABLE,   [1]);
   GLRandom.SetPicker(RND_VX_NEW_GROUP,            [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VX_DO_SHUFFLE_STRUCT,    [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VXFMT_COORD_SIZE,        [4]);
   GLRandom.SetPicker(RND_VXFMT_COORD_DATA_TYPE,   [GL_FLOAT]);
   GLRandom.SetPicker(RND_VXFMT_HAS_NORMAL,        [GL_TRUE]);
   GLRandom.SetPicker(RND_VXFMT_NORMAL_DATA_TYPE,  [GL_FLOAT]);
   GLRandom.SetPicker(RND_VXFMT_HAS_PRICOLOR,      [GL_TRUE]);
   GLRandom.SetPicker(RND_VXFMT_HAS_EDGE_FLAG,     [GL_FALSE]);
   GLRandom.SetPicker(RND_VXFMT_TXU_COORD_SIZE,    [4]);
   GLRandom.SetPicker(RND_VXFMT_HAS_SECCOLOR,      [GL_TRUE]);
   GLRandom.SetPicker(RND_VXFMT_HAS_FOG_COORD,     [GL_TRUE]);
   GLRandom.SetPicker(RND_VXFMT_HAS_WEIGHT,        [GL_TRUE]);

   // not supported by fakegl
   GLRandom.SetPicker(RND_VX_COMPILED_ENABLE, [0]);

   GLRandom.SetPicker(RND_VX_SEND_METHOD,
      [ "random",
         [ 1, RND_VX_SEND_METHOD_Array ],
         [ 1, RND_VX_SEND_METHOD_DrawElements ],
         [ 1, RND_VX_SEND_METHOD_DrawArrays ],
      ] );

   GLRandom.SetPicker(RND_TX_NAME, [RND_TX_NAME_Random]);

   GLRandom.SetPicker(RND_TX_INTERNAL_FORMAT,
      [ "random",
         //[ 1, 1],
         //[ 1, 2],
         //[ 1, GL_RGB],
         [ 1, GL_RGBA],
         //[ 1, GL_ALPHA],
         [ 1, GL_LUMINANCE],
         [ 1, GL_LUMINANCE_ALPHA],
         [ 1, GL_INTENSITY],
         [ 1, GL_COMPRESSED_RGB_S3TC_DXT1_EXT],
         [ 1, GL_COMPRESSED_RGBA_S3TC_DXT1_EXT],
         [ 1, GL_COMPRESSED_RGBA_S3TC_DXT3_EXT],
         [ 1, GL_COMPRESSED_RGBA_S3TC_DXT5_EXT],
         [ 1, GL_COLOR_INDEX8_EXT],
         [ 1, GL_SIGNED_RGBA_NV],
         //[ 1, GL_SIGNED_RGB_NV],
         [ 1, GL_SIGNED_LUMINANCE_NV],
         [ 1, GL_SIGNED_LUMINANCE_ALPHA_NV],
         //[ 1, GL_SIGNED_ALPHA_NV],
         [ 1, GL_SIGNED_INTENSITY_NV],
         [ 1, GL_SIGNED_RGB_UNSIGNED_ALPHA_NV],
         [ 1, GL_HILO_NV],
         [ 1, GL_SIGNED_HILO_NV],
         [ 1, GL_DSDT_NV],
         //[ 1, GL_DSDT_MAG_NV],
         [ 2, GL_DSDT_MAG_INTENSITY_NV],
      ] );

   GLRandom.SetPicker(RND_CMB_INPUT_REG,
      [ "random",
         [ 2, GL_PRIMARY_COLOR_NV],
         [ 2, GL_SECONDARY_COLOR_NV],
         [ 5, GL_TEXTURE0_ARB],
         [ 5, GL_TEXTURE1_ARB],
         [ 5, GL_TEXTURE2_ARB],
         [ 5, GL_TEXTURE3_ARB],
         [ 5, GL_SPARE0_NV],
         [ 5, GL_SPARE1_NV],
         [ 1, GL_FOG],
         [ 1, GL_CONSTANT_COLOR0_NV],
      ] );

   GLRandom.SetPicker(RND_CMB_OUTPUT_REG,
      [ "list",
         GL_DISCARD_NV,
         GL_DISCARD_NV,
         GL_SPARE0_NV,

         GL_DISCARD_NV,
         GL_DISCARD_NV,
         GL_SPARE0_NV,

         GL_DISCARD_NV,
         GL_DISCARD_NV,
         GL_SPARE1_NV,

         GL_DISCARD_NV,
         GL_DISCARD_NV,
         GL_SPARE1_NV,
      ] );


   GLRandom.SetPicker(RND_TXU_ENABLE_MASK,
      [ "random",
         [ 1, 0xf],
      ] );

   GLRandom.SetPicker(RND_LIGHT_ENABLE, [GL_TRUE]);
   GLRandom.SetPicker(RND_LIGHT_MODEL_TWO_SIDE, [GL_TRUE]);
   GLRandom.SetPicker(RND_LIGHT_NUM_ON, [2]);
   GLRandom.SetPicker(RND_LIGHT_TYPE,
      [ "random",
         [ 1, RND_LIGHT_TYPE_Directional],
         [ 1, RND_LIGHT_TYPE_PointSource],
         // [ 1, RND_LIGHT_TYPE_SpotLight ],
      ]);

   GLRandom.SetPicker(RND_GEOM_CULL_FACE,
      [ "random",
         [ 1, GL_FALSE],
      ] );
   GLRandom.SetPicker(RND_GEOM_FRONT_FACE, [GL_CCW]);
   GLRandom.SetPicker(RND_GEOM_USE_PERSPECTIVE, [GL_FALSE]);

   GLRandom.SetPicker(RND_VX_PER_LOOP,
      [ "random",
         [ 1, 1, 16],
      ] );

   GLRandom.SetPicker(RND_FRAG_BLEND_EQN,
      [ "random",
         [ 95, GL_FUNC_ADD_EXT],
         [ 2, GL_MAX_EXT],
         [ 1, GL_MIN_EXT],
         [ 1, GL_FUNC_SUBTRACT_EXT],
         [ 1, GL_FUNC_REVERSE_SUBTRACT_EXT],
      ] );

   GLRandom.SetPicker(RND_FRAG_DEPTH_FUNC,
      [ "random",
         [ 1, GL_LESS ],
         [ 1, GL_ALWAYS ],
      ] );

   GLRandom.SetPicker(RND_FRAG_STENCIL_FUNC,
      [ "random",
         [ 20, GL_ALWAYS],
         [ 2, GL_LESS],
         [ 2, GL_NOTEQUAL],
         [ 2, GL_LEQUAL],
         [ 2, GL_GEQUAL],
         [ 2, GL_GREATER],
         [ 2, GL_EQUAL],
         [ 1, GL_NEVER],
      ] );

   GLRandom.SetPicker(RND_CMB_NUM_STAGES,
      [ "random",
         [ 1, 1, 4],
      ] );

   GLRandom.SetPicker(RND_CMB_THEME,
      [ "random",
         [ 5,  RND_CMB_THEME_Random],
         [ 50, RND_CMB_THEME_4WayBlend],
         [ 25, RND_CMB_THEME_NormalMap],
      ] );
   GLRandom.SetPicker(RND_FRAG_SCISSOR_ENABLE, [GL_FALSE]);

   //GLRandom.SetPicker(RND_TX_DIM,
   //   [ "random",
   //      [ 4, GL_TEXTURE_2D],
   //      [ 1, GL_TEXTURE_3D],
   //      [ 1, GL_TEXTURE_CUBE_MAP_EXT],
   //      [ 1, GL_TEXTURE_1D],
   //      [ 1, GL_TEXTURE_2D], //GL_TEXTURE_RECTANGLE_NV],
   //   ]);

}

function glr_fakegl2()
{
   var nAcross = 7;
   var nDown   = 6;
   var lpf     = nAcross * nDown * 1;

   GLRandom.Golden.Action                       = Golden.Skip;
   GLRandom.Golden.SkipCount                    = lpf;
   GLRandom.TestConfiguration.RestartSkipCount  = lpf;
   GLRandom.TestConfiguration.Loops             = lpf * 40;
   GLRandom.TestConfiguration.DisplayWidth      = 640;
   GLRandom.TestConfiguration.DisplayHeight     = 480;
   GLRandom.TestConfiguration.UseTiledSurface   = false;

   // C++ default tables
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();

   // don't allow sw fallback stuff
   //glr_avoid_software_paths();
   glr_progressive();

   // Force a standard vertex format.
   GLRandom.SetPicker(RND_VXFMT_COORD_SIZE,        [4]);
   GLRandom.SetPicker(RND_VXFMT_COORD_DATA_TYPE,   [GL_FLOAT]);
   GLRandom.SetPicker(RND_VXFMT_HAS_NORMAL,        [GL_TRUE]);
   GLRandom.SetPicker(RND_VXFMT_NORMAL_DATA_TYPE,  [GL_FLOAT]);
   GLRandom.SetPicker(RND_VXFMT_HAS_PRICOLOR,      [GL_TRUE]);
   GLRandom.SetPicker(RND_VXFMT_HAS_EDGE_FLAG,     [GL_FALSE]);
   GLRandom.SetPicker(RND_VXFMT_TXU_COORD_SIZE,    [4]);
   GLRandom.SetPicker(RND_VXFMT_HAS_SECCOLOR,      [GL_TRUE]);
   GLRandom.SetPicker(RND_VXFMT_HAS_FOG_COORD,     [GL_TRUE]);
   GLRandom.SetPicker(RND_VXFMT_HAS_WEIGHT,        [GL_TRUE]);
   GLRandom.SetPicker(RND_VX_NEW_GROUP,            [ GL_FALSE ]);
   GLRandom.SetPicker(RND_VX_DO_SHUFFLE_STRUCT,    [ GL_FALSE ]);

   // all random tx images
   GLRandom.SetPicker(RND_TX_NAME, [RND_TX_NAME_Random]);

   // Fill the screen nicely with simple quads.
   GLRandom.SetPicker(RND_GEOM_BBOX_WIDTH,    [RND_GEOM_WorldWidth/nAcross - 100]);
   GLRandom.SetPicker(RND_GEOM_BBOX_HEIGHT,   [RND_GEOM_WorldHeight/nDown - 100]);
   GLRandom.SetPicker(RND_GEOM_BBOX_DEPTH,    [ RND_GEOM_WorldDepth/2      ]);
   GLRandom.SetPicker(RND_GEOM_BBOX_Z_BASE,   [ RND_GEOM_WorldDepth/2      ]);
   GLRandom.SetPicker(RND_GEOM_BBOX_XOFFSET,  [RND_GEOM_WorldWidth/nAcross + 1]);
   GLRandom.SetPicker(RND_GEOM_BBOX_YOFFSET,  [RND_GEOM_WorldHeight/nDown + 1]);
   GLRandom.SetPicker(RND_GEOM_FORCE_BIG_SIMPLE,        [ GL_TRUE ]);
   GLRandom.SetPicker(RND_VX_PRIMITIVE,                 [ GL_QUADS ]);
   GLRandom.SetPicker(RND_VX_PER_LOOP,                  [ 4 ]);
   GLRandom.SetPicker(RND_PRIM_POLY_MODE,               [ GL_FILL ]);
   GLRandom.SetPicker(RND_VX_W,                         [ 1.0 ]);
   GLRandom.SetPicker(RND_GEOM_USE_PERSPECTIVE,         [ GL_FALSE ]);
   GLRandom.SetPicker(RND_GEOM_VERTEX_WEIGHTING_ENABLE, [ GL_FALSE ]);

   // not supported by fakegl
   GLRandom.SetPicker(RND_VX_COMPILED_ENABLE, [0]);

   // Since we are using the minimal state mode, force the JS to match what
   // the emitted code is going to do anyway.
   GLRandom.SetPicker(RND_VX_SEND_METHOD,
      [ "random",
         [ 1, RND_VX_SEND_METHOD_Array ],
         [ 1, RND_VX_SEND_METHOD_DrawElements ],
         [ 1, RND_VX_SEND_METHOD_DrawArrays ],
      ] );
   GLRandom.SetPicker(RND_LIGHT_ENABLE, [GL_TRUE]);
   GLRandom.SetPicker(RND_LIGHT_MODEL_TWO_SIDE, [GL_TRUE]);
   GLRandom.SetPicker(RND_LIGHT_NUM_ON, [2]);
   GLRandom.SetPicker(RND_LIGHT_TYPE,
      [ "random",
         [ 1, RND_LIGHT_TYPE_Directional],
         [ 1, RND_LIGHT_TYPE_PointSource],
         // [ 1, RND_LIGHT_TYPE_SpotLight ],
      ]);

   // More interesting, visible draws.
   GLRandom.SetPicker(RND_GEOM_CULL_FACE, [ GL_FALSE ]);
   GLRandom.SetPicker(RND_GEOM_FRONT_FACE, [GL_CCW]);
   GLRandom.SetPicker(RND_GEOM_BBOX_FACES_FRONT, [GL_TRUE]);


   // emit the fakegl.
   GLRandom.SetPicker(RND_TSTCTRL_EMIT_FAKE_GL, [GL_TRUE]);
   GLRandom.FakeGLTexImages      = false;
   GLRandom.FakeGLMinimalState   = true;
   GLRandom.Golden.DumpTga       = Golden.OnSkip;
   GLRandom.Golden.Print         = Golden.Never;//Golden.Always;

   LevVerbose();

   GLRandom.Run();
}

//------------------------------------------------------------------------------
// Experiments to isolate a repeatability bug:
function z()
{
   //DosOpenGL.Registry.DebugOptions = 1;
   //DosOpenGL.Registry.DebugMask = 0x00400000;
   //DosOpenGL.Registry.DebugLevel = 50;

   //
   // Turn everything off except the simplest colored triangles.
   //
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();
   glr_boring();
   GLRandom.ClearLines = true;
   
   //
   // Turn things back on.
   //
   RandomEnables =
   [
      true,  // RND_CMB
      true,  // RND_EVAL
      true,  // RND_FOG
      true,  // RND_FRAG
      true,  // RND_GEOM
      true,  // RND_LIGHT
      true,  // RND_PRIM
      true,  // RND_TX
      true,  // RND_VX
      true,  // RND_VXFMT
   ];
   for (i = 0; i < RND_NUM_RANDOMIZERS; i++)
   {
      if (RandomEnables[i])
         GLRandom.SetDefaultPicker(i*RND_BASE_OFFSET, i*RND_BASE_OFFSET + RND_BASE_OFFSET - 1);
   }
   glr_avoid_software_paths();

   // var nAcross = 25;
   // var nDown   = 20;
   // GLRandom.SetPicker(RND_GEOM_BBOX_YOFFSET,             [ RND_GEOM_WorldHeight/nDown + 5]);
   // GLRandom.SetPicker(RND_GEOM_BBOX_XOFFSET,             [ RND_GEOM_WorldWidth/nAcross  + 5]);
   // GLRandom.SetPicker(RND_GEOM_BBOX_WIDTH,               [ RND_GEOM_WorldWidth/nAcross - 27]);
   // GLRandom.SetPicker(RND_GEOM_BBOX_HEIGHT,              [ RND_GEOM_WorldHeight/nDown - 27]);
   // GLRandom.SetPicker(RND_VX_PRIMITIVE,                  [ RND_VX_PRIMITIVE_Solid ]);
   // GLRandom.SetPicker(RND_GEOM_FORCE_BIG_SIMPLE,         [ GL_TRUE ]);

   // Experiments here...
   //GLRandom.SetPicker(RND_VX_PER_LOOP, ["random", [1, 1, 50]]);
   //GLRandom.SetPicker(RND_FRAG_BLEND_EQN, [GL_FUNC_ADD_EXT]);
   //GLRandom.SetPicker(RND_FRAG_BLEND_EQN, [0]);

   //GLRandom.SetPicker(RND_TX_DIM, [ GL_TEXTURE_2D ]);
   //GLRandom.SetPicker(RND_TX_WIDTH, [ 256 ]);
   //GLRandom.SetPicker(RND_TX_HEIGHT, [ 256 ]);
   //GLRandom.SetPicker(RND_TX_BASE_MM, [ 0 ]);
   //GLRandom.SetPicker(RND_TX_MAX_MM, [ 100 ]);
   //GLRandom.SetPicker(RND_TX_NAME, [ RND_TX_NAME_Random ]);
   //GLRandom.SetPicker(RND_TXU_ENABLE_MASK, [ 0x1 ]);
   //GLRandom.SetPicker(RND_TXU_WRAPMODE, [ GL_REPEAT ]);
   //GLRandom.SetPicker(RND_TXU_MIN_FILTER, [ GL_NEAREST ]);
   //GLRandom.SetPicker(RND_TXU_MAG_FILTER, [ GL_NEAREST ]);
   //GLRandom.SetPicker(RND_TXU_MIN_LAMBDA, [ 0.0 ]);
   //GLRandom.SetPicker(RND_TXU_MAX_LAMBDA, [ 0.0 ]);
   //GLRandom.SetPicker(RND_TXU_BIAS_LAMBDA, [ 0.0 ]);
   //GLRandom.SetPicker(RND_TXU_MAX_ANISOTROPY, [ 1.0 ]);
   GLRandom.SetPicker(RND_TX_INTERNAL_FORMAT, [ "random",
         [  5,GL_RGBA8                          ],
         [  1,GL_LUMINANCE8                     ],
         [  1,GL_LUMINANCE8_ALPHA8              ],
         [  1,GL_RGB5                           ],
         [  1,GL_RGB8                           ],
         [  1,GL_RGBA4                          ],
         [  1,GL_RGB5_A1                        ],
         [  1,GL_ALPHA8                         ],
         [  1,GL_INTENSITY8                     ],
         [  1,GL_SIGNED_LUMINANCE8_NV           ],
         [  1,GL_SIGNED_LUMINANCE8_ALPHA8_NV    ],
         [  1,GL_SIGNED_RGB8_NV                 ],
         [  1,GL_SIGNED_RGBA8_NV                ],
         [  1,GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV ],
         [  1,GL_SIGNED_ALPHA8_NV               ],
         [  1,GL_SIGNED_INTENSITY8_NV           ],
         [  1,GL_HILO16_NV                      ],
         [  1,GL_SIGNED_HILO16_NV               ],
         [  1,GL_DSDT8_NV                       ],
         [  1,GL_DSDT8_MAG8_NV                  ],
         [  1,GL_DSDT8_MAG8_INTENSITY8_NV       ],
         [  1,GL_HILO8_NV                       ],
         [  1,GL_SIGNED_HILO8_NV                ],
         [  1,GL_COLOR_INDEX8_EXT               ],
         [  1,GL_COMPRESSED_RGBA_S3TC_DXT1_EXT  ],
         [  1,GL_COMPRESSED_RGBA_S3TC_DXT3_EXT  ],
         [  1,GL_COMPRESSED_RGBA_S3TC_DXT5_EXT  ],
         [  1,GL_DEPTH_COMPONENT16_SGIX         ],
         [  1,GL_DEPTH_COMPONENT24_SGIX         ],
         [  3,GL_FLOAT_R32_NV                   ],
         [  3,GL_FLOAT_RGBA32_NV                ],
         [  3,GL_FLOAT_RGBA16_NV                ],
         ]);
   
   //GLRandom.SetPicker(RND_TX_DEPTH, [ 64 ]);
   //GLRandom.SetPicker(RND_TX_HAS_BORDER, [ GL_FALSE ]);
   //GLRandom.SetPicker(RND_TX_SHADER_ENABLE, [ GL_FALSE ]);
   //GLRandom.SetPicker(RND_TXSH_PROG, [ RND_TXSH_PROG_TxNd ]);
   //GLRandom.SetPicker(RND_TX_FRAG_PROG_ENABLE, [ GL_FALSE ]);
   //GLRandom.SetPicker(RND_TX_NUM_OBJS, [30]);
   //GLRandom.SetPicker(RND_TX_MAX_TOTAL_BYTES, [1024*1024*4]);
   GLRandom.SetPicker(RND_TSTCTRL_FLUSH, [GL_FALSE]);
}

function zed(frame, loop, doCheck, doDump)
{
   GLRandom.TestConfiguration.Seed              = 0x12345678;
   GLRandom.TestConfiguration.StartLoop         = (frame -1) * GLRandom.TestConfiguration.RestartSkipCount;
   GLRandom.TestConfiguration.Loops             = 2 * GLRandom.TestConfiguration.RestartSkipCount;
   GLRandom.TestConfiguration.UseTiledSurface   = false;
   //GLRandom.TestConfiguration.DisplayWidth      = 1024;
   //GLRandom.TestConfiguration.DisplayHeight     = 768;
   //GLRandom.ClearLines                          = false;
   //GLRandom.TestConfiguration.RestartSkipCount  = 500;
   //GLRandom.Golden.SkipCount                    = 1;
   GLRandom.Golden.Codes                        = Golden.CheckSums;
   GLRandom.Golden.NumCodeBins                  = 97;
   GLRandom.AllowedSoftErrors                   = 0;
   GLRandom.FrameRetries                        = 4;
   GLRandom.Golden.StopOnError               = true;
   GLRandom.Golden.AllowedBadBinsOneCheck    = 0;
   GLRandom.Golden.AllowedSumDiffOneCheck    = [ 0, // alpha
                                                 0, // red
                                                 0, // green
                                                 0, // blue
                                                 0, // stencil
                                                 0  // depth
                                               ];
   GLRandom.DoubleBuffer                        = true;
   GLRandom.SetDefaultPicker(0, RND_NUM_RANDOMIZERS*RND_BASE_OFFSET);
   GLRandom.FreeUserFragmentPrograms();

   if (!doCheck)
   {
      GLRandom.Golden.Action                    = Golden.Store;
   }
   else
   {
      GLRandom.Golden.Action                    = Golden.Check;
   }

   z();

   //var numToSkip = (loop%GLRandom.TestConfiguration.RestartSkipCount);
   //@@@@ GLRandom.SetPicker(RND_TSTCTRL_SKIP, ["list", [numToSkip, 1], [1, 0], [GLRandom.TestConfiguration.RestartSkipCount-1-numToSkip,1]] );

   if (!doDump)
   {
      GLRandom.Golden.DumpTga    = Golden.Never;
      GLRandom.Golden.Pause      = Golden.Never;
   }
   else
   {
      GLRandom.Golden.DumpTga    = Golden.OnStore | Golden.OnError;
      GLRandom.Golden.Pause      = Golden.Never; //Golden.OnStore | Golden.OnError;
      //@@@ GLRandom.FakeGLTexImages = true;
      GLRandom.SetPicker(RND_TSTCTRL_EMIT_FAKE_GL, [1]);
      DosOpenGL.Registry.CaptureEnable = 1; //enable acf capture for error dump
   }


   if ( GLRandom.Run() )
      glr_print_miscompare_details();

   DosOpenGL.Registry.CaptureEnable = 0;
}


